
var eq_frase 	= 0;
var click 		= (('ontouchend' in window)) ? 'touchend' : 'click';
var checked 	= 0;
var dragging 	= false;
var frase_buena = [];
var frase_mala  = [];
var band		= 0;
var eq 			= 0;
var total		= 0;


function preventMove(e) {
	e.preventDefault();
	return false;
};

var posicionar = function(){
	ims.interfaz.resize();
}

function scroll() {
	if ($("#intro_text").html() == null) {

		$('#visor').jScrollPane({
			contentWidth : 0,
			horizontalGutter : -30,
			verticalGutter : -30,
			autoReinitialise : true
		});
	} else {
		
		$('#visor').width($('#content').width() + 40);
		$('#visor').jScrollPane({
			contentWidth : 0,
			horizontalGutter : -30,
			verticalGutter : -30,
			autoReinitialise : true
		});
	}
}

$(document).ready(function() {
	// if ($("#url_interfaz").text() != "") {
	// 	url_interfaz = $("#url_interfaz").text();
	// };
	$("#url_interfaz").remove();
	
	url_files=config_json.path;
	ims.interfaz.setSound( 'good', url_interfaz + 'audio/good.mp3' );
	ims.interfaz.setSound( 'bad', url_interfaz + 'audio/bad.mp3' );
	ims.interfaz.init();

	if (isMobile) {
		document.addEventListener("touchmove", function(e) {
			e.preventDefault();
			return false;
		}, false);
		if (isiOS) {
			$("body").css("margin-top", "-20px");
		};
		$(".notdisabled").bind("touchstart", function() {
			$(this).addClass("active");
		}).bind("touchend", function() {
			$(this).removeClass("active");
		});
	}
	if ( typeof (editable) != "undefined") {
		cargar_actividad();
	} else {
		inicializar();
	};
	$("#overall").remove();
	
	objFoto = config_json.fondo.path;
	if( objFoto != "" ){
		if( url_files != "" ){
			img  = url_files + objFoto;
		}
		else{
			img  = url_files + objFoto;
		}
		$( "#fondo" ).css( "background-image", "url(" + img + ")" );
		$( '#fondo' ).css( "background-repeat", "no-repeat" );
		$( '#fondo' ).css( "background-position", config_json.fondo.x + "px " + config_json.fondo.y + "px" );
		$( '#fondo' ).css( "background-size", config_json.fondo.width + "px " + config_json.fondo.height + "px" );
		$(' #visor' ).css('background','none');
	}

});


function inicializar() {
	cargar_actividad();
	scroll();

	//fix persistencia scrollbar en la 1a pantalla
	var pane = $('#visor');
	var api = pane.data('jsp');
	api.scrollTo(parseInt($('#toX').val()), 0);
}

function cargar_actividad() {

	$(".ui-loader,.ui-page").remove();
 	document.title = 'Santillana';

    ims.interfaz.addButton("versolucion2", "left", "versolucion", config_json.textos.solucionar);
	ims.interfaz.addButton("comprobar1", "left", "comprobar", config_json.textos.comprobar);
    ims.interfaz.addButton("aleatorio", "right", "aleatorio", config_json.textos.aleatorio);
    ims.interfaz.addButton("reiniciar4", "right", "reiniciar", config_json.textos.reiniciar);

    ims.interfaz.enable("reiniciar4");
	ims.interfaz.bind("reiniciar4", 'pintar_signos()');

	// Enunciados respuestas y caracteres
	var enunciado = config_json.textos.enunciado !== undefined ? config_json.textos.enunciado : '';

	ims.interfaz.setTitle(config_json.textos.titulo);
	
	$('#pregunta').append( enunciado.replace(/<br>/g, "") );
		//solo si hay texto enunciado mostrar el boton orden
    if( $('#pregunta').text() !== '') {
        var orden = config_json.textos.orden;
        if( typeof orden == "undefined" || orden == '') {
            orden = 'Orden';
        }
        console.log( orden );
        //añadir boton icon de mostrar/ocultar la orden 
        ims.interfaz.addButton("orden1", "left", "orden", orden);
        ims.interfaz.bind("orden1", "toggle_enunciado()");
        ims.interfaz.enable("orden1");
        //asignar al p dentro del enunciado la clase pregunta_inf que le pone el borde rojo
        $('#pregunta').addClass('pregunta_inf');
        $('#pregunta').css('position', 'absolute');
    }
    else{
        $('#pregunta').hide();
    }

	posicionar();
	$('#visor').append('<div id="contenedora"></div>');

	//Recorremos todas las frases para guardarlas en un array
	$.each(config_json.frases, function(i) {
	    frase_buena[i] = config_json.frases[i].frase;
	    //Le quitamos todos los signos
		frase_mala[i] 	= ((((((((config_json.frases[i].frase).replace('.','')).replace(',','')).replace(':','')).replace('¿','')).replace('?','')).replace('¡','')).replace('!',''));
		//Le añadimos espacios
		frase_mala[i]	= frase_mala[i].replace(/ /g,'<span class="hueco" style="text-align:left;">&nbsp;</span><span class="hueco" style="text-align:right;">&nbsp;</span>');
		//Y al principio y al final de la frase también
		frase_mala[i]	= '<div id="frase'+i+'" class="frase"><span class="hueco" style="text-align:right;">&nbsp;</span>'+frase_mala[i]+'<span class="hueco" style="text-align:left;">&nbsp;</span></div>';
		frase_mala[i]	= frase_mala[i].replace('<br>','<span class="hueco" style="text-align:left;">&nbsp;</span><br><span class="hueco" style="text-align:right;">&nbsp;</span>');
		total = i;
	});

	frase_mala = desordenar_array(frase_mala);
	
	pintar_signos();

	//Activamos el aleatorio
	if (frase_buena.length > 1){
		ims.interfaz.enable("aleatorio");
		ims.interfaz.bind("aleatorio", 'aleatorio()');
	}

	$(".signo").live('mousedown', function(e) {
		if (!isMobile){
			e.preventDefault();
			//Le añadimos una clase para quitarle lo que ya tiene
			if ($('.verde').length == 0 && $('.rojo').length == 0){
				$(this).addClass('moviendo');
			}
			if ($(this).parent().attr('class') != 'posicion'){
				if (checked == 0) {
					if(isMoz == true){
						var z = ($("#limit").css("-moz-transform"));

					}else{
					var z = parseFloat($("#limit").css("zoom"));

					}
					if(z=='none' || typeof(z)=='undefined')
						z=1;

					xMouse = e.pageX-(($(this).offset().left)*z);
					yMouse = e.pageY - ($(this).offset().top*z);
					xMouse = xMouse/z;
					yMouse = yMouse/z;
					draggingObj = $(this);
					if ($(this).attr("posicion") == 0) {
						draggingObj.css({
							"top" : draggingObj.attr("top"),
							"left" : draggingObj.attr("left")
						});
						$("#box").append($(this).get());
						$(this).attr("posicion","-1");
					}
					dragging = true;
					objoff = $(this).offset();

				};
			}
		}
	});

	$(document).live('mousemove', function(e) {
		if(dragging==true && $('.verde').length == 0 && $('.rojo').length == 0){
			
			if(isMoz == true){
				var z = ($("#limit").css("-moz-transform"));

			}else{
			var z = parseFloat($("#limit").css("zoom"));

			}
			if(z=='none' || typeof(z)=='undefined')
				z=1;
			var leftOriginalZoom = e.pageX-(($("#limit").offset().left)*z);
			var leftO = (leftOriginalZoom/z);
			var topOriginalZoom = e.pageY-(($("#limit").offset().top)*z)+20;
			var topO = (topOriginalZoom/z);
			move(draggingObj, leftO-xMouse, topO-yMouse);
		}
	});

	
	$('.signo').live("mouseup", function(e) {
		$(this).removeClass('moviendo');
	});

	$(document).live("mouseup", function(e) {
		if (dragging) {
			suelta();
			if ($('.verde').length == 0 && $('.rojo').length == 0){
				ims.interfaz.enable("comprobar1");
				ims.interfaz.bind("comprobar1", 'comprobar()');
			}
		}
	});

	
	//Para la tablet
	$('.hueco').live( click, function(e){
		if(isMobile && $('.moviendo_tablet').length > 0){
			$(this).text($('.moviendo_tablet').text());
			$(this).addClass('clarito');
			ims.interfaz.enable("comprobar1");
			ims.interfaz.bind("comprobar1", 'comprobar()');
		}
	});
	$('.posicion').live( click, function(e){
		e.preventDefault();
		if (isMobile && $(this).index() == ($('.seleccion').attr('id')).replace('palabra','')){
			$(this).html('<div class="palabra2">'+$('.seleccion').text()+'</div>');
			$('.seleccion').text('');
			$('.seleccion').removeClass('seleccion');
		}
	});
	scroll();	

	if ($('.frase').find('br').length == 1){
		$('.frase').css('text-align','left');
	}else{
		$('.frase').css('text-align','center');
	}

};

function desordenar_array(bar){
   	var m= bar.length-1;
  	for (var i=m;i>1;i--){ 
      alea=Math.floor(i*Math.random()); 
      temp=bar[i]; 
       bar[i]=bar[alea]; 
       bar[alea]=temp; 
    }
   	return(bar);
}

function move(obj, x, y) {
	obj.css({
		"left" : (parseInt(x)) + "px",
		"top" : (parseInt(y))-100 + "px"
	});
};

function suelta() {
	var obj = draggingObj;
	var counter = 0;

	$(".hueco").each(function() {
		if (obj.attr("id") != "box"){
			if (intersects(obj, $(this)) && !($(this).attr("id"))) {
				objoff = $(this).offset();
				counter++;
				$(this).addClass('clarito');
				obj.attr({
					"posicion" : "0",
					"left" : objoff.left + "px",
					"top" : objoff.top + "px"
				}).css({
					"top" : "0px",
					"left" : "0px"
				});
				$(this).text(obj.text());
				obj.remove();
				//$(this).append(obj.get()).attr("id", "posicion_" + obj.attr("id"));
			}
		}
	});
	if (counter == 0){
		obj.css({
			"left" : obj.attr('left')+'px',
			"top" : obj.attr('top')+'px'
		});
	}
	pintar_signos2();

	dragging = false;
};

function intersects(obj1, obj2) {
	obj1x 		= parseInt(obj1.css("left"));
	obj1y 		= parseInt(obj1.css("top"));
	obj2x 		= parseInt(obj2.css("left"));
	obj2y 		= parseInt(obj2.css("top"));
	obj1width 	= obj1.width();
	obj1height	= obj1.height();
	obj2width 	= obj2.width();
	obj2height 	= obj2.height();
	obj1off		= obj1.offset();
	obj2off 	= obj2.offset();

	if (obj1off.left + obj1width < obj2off.left) {
		return false;
	};
	if (obj1off.top + obj1height < obj2off.top) {
		return false;
	};
	if (obj1off.left > obj2off.left + obj2width) {
		return false;
	};
	if (obj1off.top > obj2off.top + obj2height) {
		return false;
	};
	return true;
};

function comprobar(){
	ims.interfaz.disable("comprobar1");
	ims.interfaz.bind("comprobar1", 'nohacernada()');
	var comp = (((config_json.frases[$('.frase').attr('id').replace('frase','')].frase).replace(/\s/g, ''))).replace('<br>','');
	if (($('.frase').text()).replace(/\s/g, '') == comp){
		//BIEN
		solucionar();
	}else{
		//MAL
		$('.frase').addClass('rojo');
		ims.interfaz.playSound('bad');	
		ims.interfaz.enable("versolucion2");
		ims.interfaz.bind("versolucion2", 'solucionar()');
	}
}

function solucionar(){
	ims.interfaz.disable("versolucion2");
	ims.interfaz.bind("versolucion2", 'nohacernada()');
	$('.frase').text((config_json.frases[eq_frase].frase).replace('<br>',' '));
	$('.frase').addClass('verde').removeClass('rojo');
	ims.interfaz.showStars($('.frase'));
	ims.interfaz.playSound('good');
}

function pintar_signos(){
	$('.hueco').text('');
	$('.signo').remove();

	$('.verde').removeClass('verde');
	$('.rojo').removeClass('rojo');
	
	//Añadimos la frase
	//Metemos la frase sin signos
	$('.frase').remove();
	//$('#contenedora').append(frase_mala[0]);
	$('#contenedora').append(frase_mala[eq]);

	//Introducimos los signos
	$('#signos').remove();
	$('#contenedora').append('<div id="signos"></div>');

	pintar_signos2();

	ims.interfaz.disable("comprobar1");
	ims.interfaz.bind("comprobar1", 'nohacernada()');
	ims.interfaz.disable("versolucion2");
	ims.interfaz.bind("versolucion2", 'nohacernada()');

	eq_frase = ($('.frase').attr('id')).replace('frase','');
}

function pintar_signos2(){
	$('.signo').remove();
	var b=155;
	for (var i=0;i<7;i++){
		b = b+80;
		$('#signos').append('<div left='+b+' top="301" style="left:'+b+'px" class="signo"></div>');
	}
	$('.signo').eq(0).text('.');
	$('.signo').eq(1).text(',');
	$('.signo').eq(2).text(':');
	$('.signo').eq(3).text('¿');
	$('.signo').eq(4).text('?');
	$('.signo').eq(5).text('¡');
	$('.signo').eq(6).text('!');

	//Para la tablet
	$('.signo').bind( click, function(e){
		if (isMobile){
			$('.signo').removeClass('moviendo_tablet');
			$(this).addClass('moviendo_tablet');
		}
	});
}

function toggle_enunciado() {
    $('#pregunta').fadeToggle();
}

function aleatorio(){
	//frase_mala.shift();
	ims.interfaz.disable("versolucion2");
	ims.interfaz.bind("versolucion2", 'nohacernada()');
	ims.interfaz.disable("comprobar1");
	ims.interfaz.bind("comprobar1", 'nohacernada()');
	$('.frase').remove();
	eq = parseInt(Math.floor(Math.random() * (total-0+1)) + 0);
	$('#contenedora').prepend(frase_mala[eq]);
	eq_frase = ($('.frase').attr('id')).replace('frase','');
	if (frase_mala.length == 1){
		//ims.interfaz.disable("aleatorio");
		//ims.interfaz.bind("aleatorio", 'nohacernada()');
		//Recorremos todas las frases para guardarlas en un array
		$.each(config_json.frases, function(i) {
		    frase_buena[i] = config_json.frases[i].frase;
		    //Le quitamos todos los signos
			frase_mala[i] 	= ((((((((config_json.frases[i].frase).replace('.','')).replace(',','')).replace(':','')).replace('¿','')).replace('?','')).replace('¡','')).replace('!',''));
			//Le añadimos espacios
			frase_mala[i]	= frase_mala[i].replace(/ /g,'<span class="hueco" style="text-align:left;">&nbsp;</span><span class="hueco" style="text-align:right;">&nbsp;</span>');
			//Y al principio y al final de la frase también
			frase_mala[i]	= '<div id="frase'+i+'" class="frase"><span class="hueco" style="text-align:right;">&nbsp;</span>'+frase_mala[i]+'<span class="hueco" style="text-align:left;">&nbsp;</span></div>';
			frase_mala[i]	= frase_mala[i].replace('<br>','<span class="hueco" style="text-align:left;">&nbsp;</span><br><span class="hueco" style="text-align:right;">&nbsp;</span>');
		});

		frase_mala = desordenar_array(frase_mala);
	}

	if ($('.frase').find('br').length == 1){
		$('.frase').css('text-align','left');
	}else{
		$('.frase').css('text-align','center');
	}
}

function nohacernada(){}
