/*

    Autor: Daniel Rodríguez
    Fecha: 21/04/2014 d.C

    Creación de palabras con arrastre de sílabas

*/
var dragging = false;
var draggingObj = null;
var xMouse = 0;
var yMouse = 0;
var array_general      = 0;
var array_silabas_BIEN = new Array();
var mousedown = (('ontouchend' in window)) ? 'touchend' : 'mousedown';
var mouseup = (('ontouchend' in window)) ? 'touchend' : 'mouseup';


if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener ) {
   window.addEventListener( 'DOMContentLoaded', function( e ) {
      init();
      window.addEventListener( "scroll", posicionar, false );
      window.addEventListener( "resize", posicionar, false );
      window.addEventListener( "load",  posicionar, false );
      //       if ( isMobile )
      //          document.addEventListener( "touchmove", preventMove(), false );
   }
   );
}
else{
   $(window).ready(function(){
       init();
   });
   $(window).resize(function(){
      posicionar();
   });
   $(window).load(function(){
      posicionar();
   });
   $(window).scroll(function(){
      posicionar();
   });
}

function preventMove(e) {
    e.preventDefault();
    return false;
};

var posicionar = function(){
    ims.interfaz.resize();
    if(isiOS){
        $('#bottombar').css('top','519px');
    }
}

function scroll() {
    if ($("#intro_text").html() == null) {

        $('#visor').jScrollPane({
            contentWidth : 0,
            verticalGutter : -30,
            autoReinitialise : true
        });
    } else {
        
        $('#visor').width($('#content').width() + 40);
        $('#visor').jScrollPane({
            contentWidth : 0,
            verticalGutter : -30,
            autoReinitialise : true
        });
    }
}

function init() {

    // };
    $("#url_interfaz").remove();

    url_files=config_json.path;
    ims.interfaz.setSound( 'good', url_interfaz+'audio/good.mp3' );
    ims.interfaz.setSound( 'bad', url_interfaz+'audio/bad.mp3' );
    ims.interfaz.init();
    visor = $("#visor");

    $("#overall").remove();

    objFoto = config_json.fondo.path;
    if( objFoto != "" ){
        if( url_files != "" ){
            img  = url_files + objFoto;
        }
        else {
            img  = url_files + objFoto;
        }
        $( "#fondo" ).css( "background-image", "url(" + img + ")" );
        $( '#fondo' ).css( "background-repeat", "no-repeat" );
        $( '#fondo' ).css( "background-position", config_json.fondo.x + "px " + config_json.fondo.y + "px" );
        $( '#fondo' ).css( "background-size", config_json.fondo.width + "px " + config_json.fondo.height + "px" );
    }

    cargar_actividad();
    scroll();

    //fix persistencia scrollbar en la 1a pantalla
    var pane = $('#visor');
    var api = pane.data('jsp');
}

function cargar_actividad() {
    $(".ui-loader,.ui-page").remove();
    document.title = 'Santillana';
    ims.interfaz.setTitle(config_json.textos.titulo);
    $('#pregunta').html(config_json.textos.enunciado);
    $('#pregunta').addClass("pregunta_inf");

    $('#visor').append('<div id="contenedora"></div>');     

    //Añadimos botones
    ims.interfaz.addButton("silenciar", "left", "silenciar", config_json.textos.silenciar);
    ims.interfaz.addButton("comprobar", "right", "comprobar", config_json.textos.comprobar);
    ims.interfaz.addButton("versolucion", "right", "versolucion", config_json.textos.solucionar);
    ims.interfaz.addButton("aleatorio", "right", "aleatorio", config_json.textos.aleatorio);
    ims.interfaz.addButton("reiniciar4", "right", "reiniciar", config_json.textos.reiniciar);
    ims.interfaz.addButton("orden1", "left", "orden", config_json.textos.orden);

    ims.interfaz.enable("silenciar");
    ims.interfaz.bind("silenciar", 'silenciar()');

    ims.interfaz.bind("orden1", "toggle_enunciado()");
    ims.interfaz.enable("orden1");

    $('#contenedora').append('<div id="textos"></div><div id="silabas"></div>');
    
    //Vemos cuántos grupos de palabras hay
    array_general = config_json.frases.length-1;

    if (array_general > 0){
        a_aleatorio();
    }

    mostrar_frases();

    bindDragAndDrop();
};

function mostrar_frases(){
    var ale = Math.floor(Math.random() * (array_general - 0 + 1)) + 0;
    //Creamos array con todas las sílabas del conjunto de palabras elejidas para dibujarlas posteriormente al azar
    var array_conjunto = new Array();
    //config_json.frases[ale].frase
    for (var i = 0; i<config_json.frases[ale].bloque.length; i++){
        //Frases de la palabra
        $('#textos').append('<div id="texto_'+i+'"class="texto"><div>'+config_json.frases[ale].bloque[i].frase.texto+'</div></div>');
        //Lista de cajas para introducir
        var frase_html      = config_json.frases[ale].bloque[i].frase.silaba;
        var frase_txt       = $(frase_html).children().last().text() || $(frase_html).text() || frase_html;
        var tag_html        = frase_html.replace(frase_txt,"");
        var array_silabas   = frase_txt.split('-');

        for(var b=0; b<array_silabas.length; b++){
            //Metemos las sílabas en el array general
            var silaba = array_silabas[b];
            if(tag_html != ""){
                silaba = $(tag_html).children().last().text(array_silabas[b]).parent().first();
                if(silaba[0]){
                    silaba = silaba[0].outerHTML;
                }else{

                    silaba = array_silabas[b];
                }
            }

            array_conjunto.push(silaba);
            
            //Cajitas para introducir las sílabas
            $('.texto:last').append('<div class="content_cajita"><div class="cajita"></div></div>');
        }

        array_silabas_BIEN[i] = new Array(array_silabas.length);

        for (var b = 0; b<array_silabas.length; b++){
            array_silabas_BIEN[i][b] = array_silabas[b];
        }
    }

    //Desordenamos todas las sílabas y las dibujamos
    desordenar_array(array_conjunto);
    var margin_left = 20;
    var left = margin_left;
    var left = margin_left;
    for (var i=0; i<array_conjunto.length; i++){
        $('#silabas').append('<div id="silaba_'+i+'" posicion="-1" rel="'+i+'"class="silaba drag-drop">'+array_conjunto[i]+'</div>');
        //Le damos los valores de su posición para moverlos sin problemas con el zoom
        var width = $('.silaba').eq(i).width();
        var top   = $('#silabas').position().top + 20;
        $('.silaba').eq(i).css("left", left);
        $('.silaba').eq(i).attr('x', left);
        $('.silaba').eq(i).css('top',top);
        $('.silaba').eq(i).attr('y',top);
        left = left + width + margin_left;
        
    }
    $('#silabas').css('top',top);
    $('#silabas').css('height',"100px");
    scroll();
}

function a_reiniciar(){
    ims.interfaz.enable("reiniciar4");
    ims.interfaz.bind("reiniciar4", 'reiniciar()');
}
function d_reiniciar(){
    ims.interfaz.disable("reiniciar4");
    ims.interfaz.bind("reiniciar4", 'nohacernada()');
}
function a_aleatorio(){
    ims.interfaz.enable("aleatorio");
    ims.interfaz.bind("aleatorio", 'aleatorio()');
}
function d_aleatorio(){
    ims.interfaz.disable("aleatorio");
    ims.interfaz.bind("aleatorio", 'nohacernada()');
}
function a_comprobar(){
    ims.interfaz.enable("comprobar");
    ims.interfaz.bind("comprobar", 'comprobar()');
}
function d_comprobar(){
    ims.interfaz.disable("comprobar");
    ims.interfaz.bind("comprobar", 'nohacernada()');
}
function a_solucionar(){
    ims.interfaz.enable("versolucion");
    ims.interfaz.bind("versolucion", 'solucionar()');
}
function d_solucionar(){
    ims.interfaz.disable("versolucion");
    ims.interfaz.bind("versolucion", 'nohacernada()');
}

function silenciar(){
    if( $('#silenciar').hasClass('silenciar')){
        $('#silenciar').addClass('silenciar_on').removeClass('silenciar');
        ims.interfaz.disableSound();
    }else{
        $('#silenciar').addClass('silenciar').removeClass('silenciar_on');
        ims.interfaz.enableSound();
    }
}

function comprobar(){
    d_comprobar();
    //Recorremos todas las cajas con las sílabas
    var b = 0;
    var i = 0;
    var a = 0;
    $('.texto').each( function() {
        i = 0;
        $(this).find('.cajita').each( function() {
            var id_caja = ($(this).attr('id')).replace('cajita_','');
            if (array_silabas_BIEN[b][i] == $('#'+id_caja).text()){
                //Sílaba BIEN
                $('#'+id_caja).addClass('bien');
            }else{
                //Sílaba MAL
                $('#'+id_caja).addClass('mal');
            }
            i++;
            a++;
        });
        b++;
    });

    //Con esto nos evitamos quitarlo antes y que se nos vallan los colores y fallemos en las comprobaciones
    
    d_comprobar();
    a_reiniciar();

    if ($('.mal').length == 0){
        aplauso(false);
    }else{
        ims.interfaz.playSound( 'bad' );
        a_solucionar();
    }
}

function solucionar(){
    aplauso(true);

    //Ocultamos todas las cajas de sílabas
    //Mostramos el texto correcto dentro de las cajas
    $('.cajita').css('color','#fff');
    $('.cajita').css('background-color','green');

    d_solucionar();
    a_reiniciar();
}

function reiniciar(){
    d_reiniciar();

    //Le quitamos las clases añadidas a las sílabas y a las cajitas

    $(".silaba").show();
    $('.silaba').each( function() {
        position_origen($(this));
    });

    $('.cajita').css('color','#ddd');
    $('.cajita').css('background-color','#ddd');
    $('.cajita').attr('id',"");
    $('.cajita').html("");
    //Las devolvemos a su sitio inicial
    d_solucionar();

    $('.cajita').css('color','#ddd');
}

function aleatorio(){
    $('.texto').remove();
    $('.caja_silaba').remove();
    $('.silaba').remove();
    d_comprobar();
    d_solucionar();
    mostrar_frases();
}

function aplauso(solucionar){
    //Recorremos todas las cajitas poniendo su sílaba correcta
    $('.stars').remove();
    var b = 0;
    var i = 0;
    $('.texto').each( function() {
        i = 0;
        if(solucionar){ 
            $(this).find('.cajita').each( function() {
                position_origen($(this).find(".silaba"));
                $(this).text(array_silabas_BIEN[b][i]);
                i++;
            });
        }
        b++;
        //Mostramos estrellitas y aplaudimos
        ims.interfaz.showStars($(this));
    });
    if(solucionar){
        $(".silaba").hide();
    }
    ims.interfaz.playSound('good');
}

function nohacernada(){}

function desordenar_array(bar){
    var m= bar.length-1;
    for (var i=m;i>1;i--){ 
        alea=Math.floor(i*Math.random()); 
        temp=bar[i]; 
        bar[i]=bar[alea];
        bar[alea]=temp; 
    }
    return(bar);
}



function bindDragAndDrop() {
    if(isMobile) {
        var skin = ims.interfaz.getSkin(),
            idItem = "",
            idTarget = "";
        $(".silaba").click(function () {
            if(dragging === false) {
                draggingObj = $(this);
                dragging = true;
            }
        });

        $(".cajita").click(function () {
            if(draggingObj !== null && dragging === true) {
                if(draggingObj.attr("posicion") !== 0) {
                    $(this).attr("rel", draggingObj.attr("rel"));
                    draggingObj.css({
                        left: 0,
                        top: 0
                    }).attr("posicion", "0");
                    $(this).append(draggingObj.get()).attr("id", "cajita_" + draggingObj.attr("id"));
                    draggingObj = null;
                    dragging = false;
                }
            }
        });
    }else{
        $(".silaba").live("mousedown", function (e) {
            e.preventDefault();
            if(isMoz == true) {
                var z = ims.interfaz.zoomRatio;
            }else{
                var z = ims.interfaz.zoomRatio;
            }
            if(z == 'none' || typeof (z) == 'undefined')
                z = 1;
            xMouse = e.pageX - parseFloat(($(this).offset().left) * z);
            yMouse = e.pageY - parseFloat(($(this).offset().top) * z);
            xMouse = xMouse / z;
            yMouse = yMouse / z;
            draggingObj = $(this);
            if ($(this).attr("posicion") == 0) {
                draggingObj.css({
                    "top": draggingObj.attr("top"),
                    "left": draggingObj.attr("left"),
                    "position": "absolute"
                });
                $("#silabas").append($(this).get());
                $(this).attr("posicion", "-1");
            }
            dragging = true;
            objoff = $(this).offset();
        });

        $(document).live("mousemove", function (e) {
            if(dragging == true) {
                if(isMoz == true) {
                    var z = ims.interfaz.zoomRatio;
                }else{
                    var z = ims.interfaz.zoomRatio;
                }
                if(z == 'none' || typeof (z) == 'undefined')
                    z = 1;

                var scroll_y = $("#visor").jScrollPane().data().jsp.getContentPositionY()

                var leftOriginalZoom = e.pageX - (($("#limit").offset().left) * z);
                var leftO            = (leftOriginalZoom / z);
                var topOriginalZoom  = e.pageY + scroll_y - (($("#limit").offset().top) * z);
                var topO             = (topOriginalZoom / z) - 85;
                move(draggingObj, leftO - xMouse, topO - yMouse);
            }
        });

        $(document).live("mouseup", function (e) {
            if(dragging) {
                suelta();
            }
        });
    }
    var tA = 0;
}

function suelta() {
    var obj = draggingObj;
    var counter = 0;
    $(".cajita").each(function () {
        if($(this).attr('id') == 'cajita_' + obj.attr("id"))
            $(this).attr('id', '');
        if(obj.attr("id") != "contenedora")
            if(intersects(obj, $(this)) && !($(this).attr("id"))) {
                objoff = $(this).offset();
                counter++;
                obj.attr({
                    "posicion": "0",
                    "left": obj.css('left'),
                    "top": obj.css('top')
                }).css({
                    "top": "0px",
                    "left": "0px",
                    "position": "relative"
                });
                $(this).append(obj.get()).attr("id", "cajita_" + obj.attr("id"));
                $(obj).addClass("silaba_insertada");
            }
    });
    if(counter === 0){
        position_origen(obj);
    }
    dragging = false;
    
    if($('.silaba').length === $('.silaba_insertada').length){
        a_comprobar();
    }
}

function position_origen(obj) {
    var targOff = $("#cajita_" + obj.attr("id")).offset();
    if(obj.attr("posicion") == "0") {
        $("#silabas").append(obj.get());
        obj.css({
            "left": obj.attr("x") + "px",
            "top": obj.attr("y") + "px",
            "position": "absolute"
        }, 1500).attr("posicion", "-1");
    }else{
        obj.css({
            "left": obj.attr("x") + "px",
            "top": obj.attr("y") + "px",
            "position": "absolute"
        }, 1500).attr("posicion", "-1");
    }
    $("#cajita_" + obj.attr("id")).attr("id", "");
    $(obj).removeClass("silaba_insertada");
    $(obj).removeClass("mal");
    $(obj).removeClass("bien");
}

function move(obj, x, y) {
    if(dragging)
        obj.css({
            "left": ((x)) + "px",
            "top": ((y)) + "px"
        });
}

function intersects(obj1, obj2) {
    obj1x = parseInt(obj1.css("left"));
    obj1y = parseInt(obj1.css("top"));
    obj2x = parseInt(obj2.css("left"));
    obj2y = parseInt(obj2.css("top"));
    obj1width  = obj1.width();
    obj1height = obj1.height();
    obj2width  = obj2.width();
    obj2height = obj2.height();
    obj1off    = obj1.offset();
    obj2off    = obj2.offset();
    if(obj1off.left + obj1width < obj2off.left) {
        return false;
    }
    if(obj1off.top + obj1height < obj2off.top) {
        return false;
    }
    if(obj1off.left > obj2off.left + obj2width) {
        return false;
    }
    if(obj1off.top > obj2off.top + obj2height) {
        return false;
    }
    return true;
}

function toggle_enunciado() {
    $('#pregunta').fadeToggle();
}