var tipoActividad = "Test Simple";
// var url_interfaz = "";
var url_files = "";

if (typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function(e) {
        init();
		window.addEventListener("scroll", posicionar, false);
		window.addEventListener("resize", posicionar, false);
		window.addEventListener("load", posicionar, false);
    });
}else{
	 $(window).ready(function(){
		 init();
	});
	$(window).resize(function(){
		posicionar();
	});
	$(window).load(function(){
		posicionar();
	});
	$(window).scroll(function(){
		posicionar();
	});
}


function posicionar() {

	if ($("#intro_text").html() == null) {
		// $("#carcasa").children().not(".pop_up").not("#visor").height($("#carcasa").height());
		if ( !$('#visor').hasClass( "jspScrollable" ) ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}
		// $('#visor').width($('#visor').width()).children().width($('#visor').width());
	}
	else {
		// $('#visor').width($('#content').width());

		if ( !$('#visor').hasClass( "jspScrollable" ) ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}
	}
	ims.interfaz.resize();
}

function init() {

	// if ($("#url_interfaz").text() != "") {
	// 	url_interfaz = $("#url_interfaz").text();
	// };
	$("#url_interfaz").remove();

	config_xml = $.parseXML(config_xml);
	url_files=$(config_xml).find('path').text();

	ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
	ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
	ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
	ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
	
	ims.interfaz.init();
  	inmediastudio.TRAZA.init();

	if (isMobile) {
		$(".notdisabled").bind("touchstart", function() {
			$(this).addClass("active");
		}).bind("touchend", function() {
			$(this).removeClass("active");
		});
	};
	$("#overall").remove();
	retornar();
	
	if (typeof (editable) == "undefined" && $(config_xml).find("introduccion").find("texto1").text().length != 0) {
		inicializar();
	} else {
		cargar_actividad();
	};
};

function inicializar() {
		var IntTit = $(config_xml).find("palabras").find("introduccion").text();
		var IntTex = $(config_xml).find("introduccion").find("texto1").text();
		$("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');
		
		var comenzar = $(config_xml).find("comenzar").text();

		ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());
		posicionar();
		ims.interfaz.addButton("Siguiente", "right", "siguiente ", comenzar);
		ims.interfaz.enable("Siguiente");
		ims.interfaz.bind("Siguiente", 'nextPage()');
};

function cargar_actividad() {

	
	$("#visor").removeAttr("style");
	// Imagen de fondo
	if ($(config_xml).find("foto").length != 0) {
		var foto_object = $(config_xml).find("foto");
		var foto = foto_object.text();
		var rotation = foto_object.attr("rotation");
		var width = foto_object.attr("width");
		var height = foto_object.attr("height");
		var x = foto_object.attr("x");
		var y = parseInt(foto_object.attr("y"));

		if( !showHeader ){
			y = y - HEADER_HEIGHT;
		}

		if (foto != '') {

			if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
				var ieversion = new Number(RegExp.$1);

				if (ieversion >= 8) {
					if (url_files != "") {
						foto = url_files + foto;
					} else {
						foto = url_files + foto;
					};
					$("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
					if (x == "" && y == "") {

						height = parseInt($('#fondo div img').height());
						width = parseInt($('#fondo div img').width());

						if (width < $("#fondo").width() || height < $("#fondo").height()) {
							x = $("#fondo").offset().left + $("#fondo").width() - width;
							y = $("#fondo").offset().top + $("#fondo").height() - height;
							$('#fondo div img').css({
								"margin-left" : x + "px ",
								"margin-top" : +y + "px"
							});
						};

					};
				};

			} else {
				$('#fondo').css("background-image", "url("+url_files + foto + ")");
				$('#fondo').css("background-repeat", "no-repeat");
				if (rotation != '') {
					$('#fondo').css("rotation", rotation);
					if (x != '' || y != '') {
						$('#fondo').css("background-position", x + "px " + y + "px");

						if (width != '' && height != '') {
							$('#fondo').css("background-size", width + "px " + height + "px");
						} else {
							if (height != '') {
								$('#fondo').css("background-size", "auto " + height + "px");
							} else {
								if (width != '') {
									$('#fondo').css("background-size", width + "px auto");
								};
							};
						};

					};
				};
			};

			url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
			bgImg = $('<img />');
			bgImg.hide();

			if (x == "" && y == "") {

				bgImg.bind('load', function() {
					height = parseInt($(this).height());
					width = parseInt($(this).width());

					if (width < $("#fondo").width() || height < $("#fondo").height()) {
						x = $("#fondo").offset().left + $("#fondo").width() - width;
						y = $("#fondo").offset().top + $("#fondo").height() - height;
						$('#fondo').css("background-position", x + "px " + y + "px");
					};

					bgImg.remove();
				});
			};

			$('#fondo').append(bgImg);
			bgImg.attr('src', url);

		};
	};

	// Titulo
	ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());

	var silenciar = $(config_xml).find("silenciar").text();
	var ayuda = $(config_xml).find("palabras").find("ayuda").text();
	var comprobar = $(config_xml).find("comprobar").text();
	var clave = $(config_xml).find("desarrollo").text();
	var imprimir = $(config_xml).find("imprimir").text();
	var versolucion = $(config_xml).find("versolucion").text();
	var reiniciar = $(config_xml).find("reiniciar").text();

	var aleatorio_on = $(config_xml).find("aleatorio_on").text();
	

	var volver = $(config_xml).find("volver").text();
	if (!isMobile){
		ims.interfaz.addButton("silenciar1", "left", "silenciar", silenciar);
	}

	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.addButton( "pausar", "left", "pause", $(config_xml).find("pausa").text());
	  	ims.interfaz.addButton( "player", "left", "play", $(config_xml).find("reproducir").text());
	}
	if (!isMobile && $(config_xml).find("urlimprimir").text().length>0)
		ims.interfaz.addButton("imprimir1", "left", "imprimir", imprimir);
	ims.interfaz.addButton("Anterior", "left", "anterior", volver);
	
	

	ims.interfaz.addButton("ayuda0", "right", "ayuda", ayuda);
	ims.interfaz.addButton("comprobar1", "right", "comprobar", comprobar);
	ims.interfaz.addButton("versolucion2", "right", "versolucion", versolucion);
	ims.interfaz.addButton("clave1", "right", "clave", clave);
	
	ims.interfaz.addButton("reiniciar4","right", "reiniciar", reiniciar);



	if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {
		ims.interfaz.enable("Anterior");
		ims.interfaz.bind("Anterior", 'prevPage()');
	};
		ims.interfaz.enable("silenciar1");

	if (ims.interfaz.sound) {
		ims.interfaz.bind("silenciar1", "mute()");
	} else {
		ims.interfaz.bind("silenciar1", "play()");
	};

	if ($(config_xml).find("ayuda").find("texto1").text().length != 0) {
		ims.interfaz.addPopup("ayuda", "ayuda0");
			var ayudaTit = $(config_xml).find("ayuda").find("titulo").text().replace("#29ABE2", "");
			var ayudaTex = $(config_xml).find("ayuda").find("texto1").text();
			$('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
			$('#content_ayuda').append('<div id="contenidoPOP">'+ayudaTex+'</div>');
ims.interfaz.resize();
	};

	ims.interfaz.bind("reiniciar4", 'reload()');
	ims.interfaz.bind("comprobar1", 'comprobar()');
	ims.interfaz.bind("imprimir1", "imprimir()");
	ims.interfaz.enable("reiniciar4");
	ims.interfaz.enable("comprobar1");
	ims.interfaz.enable("imprimir1");

	$(config_xml).find("respuesta").each(function() {
		var id = $(this).attr("id");
		// test simple
		ims.interfaz.bind(id, 'marcar(' + id + ')');

	});

	var numPregunta = 0;
	var _preguntas = [];

	$("#pregunta").append( $(config_xml).find("enunciadoGen").text().replace("<p>", "").replace("</p>", "") + "<div style=\"clear:both;\"></div>");
	$(config_xml).find("pregunta").each(function() {
		//Enunciados respuestas y caracteres
		var enunciado = $(this).find("enunciado").text();
		var respuesta = '';

		$(this).find("respuesta").each(function() {
			var id = $(this).attr("id");
			var idw = $(this).attr("idw");
			var caracter = $(this).attr("caracter");
			respuesta += "<div id=\"" + idw + "\" class=\"resp\"><div class=\"redondo\"><span>" + caracter + "</span></div>" + $(this).text() + "<div style=\"clear:both;\"></div></div>";
		});

		_preguntas.push('<div id="pregunta_' + numPregunta + '" class="pregunta">' + enunciado.replace("<p>", "").replace("</p>", "") + '</div><div id="respuesta">' + respuesta + '</div>');

		numPregunta++;
	});

	$(".redondo").each(function() {
		if ($(this).next("p").outerHeight() > $(this).outerHeight()) {
			$(this).css("margin-top", ($(this).parent().height() - $(this).height()) / 2);
		} else {
			$(this).next("p").css("padding-top", ($(this).height() - $(this).next("p").height()) / 2);
		}
	});
	if(aleatorio_on==1){
		$.each(_preguntas,function(index,obj){
			var n = getRandomArray(0,_preguntas.length-1);
			$("#visor").append(_preguntas[n]);
			_preguntas.splice(n,1);
		});
	}else{
		$.each(_preguntas,function(index,obj){
			$("#visor").append(obj);
		});
	}

	$(".resp").each(function(index) {
			var id = $(this).attr("id");
			ims.interfaz.bind(id, 'marcar(' + index + ',' + id + ')');
		});
 
	var tA = 0;
	$("#ayuda0").click(function() {

		if (tA == 0) {
	$("#content_ayuda").width($("#content_ayuda").width() );

			$('#content_ayuda').jScrollPane({
				showArrows : false,
				hideFocus : true
			});
			tA++;
		}
	});
	posicionar();
};

function marcar(pregunta, idRespuesta) {
	if ($("#comprobar1").hasClass("notdisabled")) {
		if ($("#" + idRespuesta).hasClass("selected")) {
			$("#" + idRespuesta).removeClass("selected");
		} else {
			$("#" + idRespuesta).addClass("selected");
		};
		ims.interfaz.playSound('beep_select');
	};
};

function imprimir() {
	window.open($(config_xml).find("urlimprimir").text(), '_blank', 'width=800,height=600');
};

function comprobar() {
	if ($("#respuesta div").hasClass("selected")) {
		if ($("#comprobar1").hasClass("notdisabled")) {
			if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
			ims.interfaz.bind("versolucion2", "solucion()");
			ims.interfaz.enable("versolucion2");
            }
 else
        {
            $("#reiniciar4").unbind('click');
            $("#reiniciar4").removeClass("notdisabled");
            $("#Anterior").unbind('click');
            $("#Anterior").removeClass("notdisabled");
        }
			var resultado = "";
			var numPregunta = 0;
			var numCorrect = 0;
			$(config_xml).find("lang").find("ES").find("pregunta").each(function() {
				var numCorrectas = 0;
				var correct = 0;
				$(this).find("respuesta").each(function() {
					var idw = $(this).attr("idw");
					var correcta = $(this).attr("val");
					if (correcta == 0) {
						numCorrectas++;
					};

					$(".selected").each(function() {
						if ((correcta != 0) && (idw == $(this).attr("id"))) {
							 if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
							$("#" + idw + "").addClass("red");
            }
							correct--;
						};

						if ((correcta == 0) && (idw == $(this).attr("id"))) {
							 if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
							$("#" + idw + "").addClass("green");
							ims.interfaz.showStars($("#" + idw));
            }
							correct++;
						};
					});
				});

				if (((correct != 0) && (numCorrectas != 0)) && (correct == numCorrectas)) {
					numCorrect++;
				};
				numPregunta++;
			});

			if ($(config_xml).find("ES > solucion").find("texto1").text().length != 0) {
				 if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
				ims.interfaz.enable("clave1");
				ims.interfaz.addPopup("solucion", "clave1");
            }
				$(config_xml).find("ES > solucion").each(function() {
					var solucionTit = $(this).find("titulo").text();
					var solucionTex = $(this).find("texto1").text();

					$('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
					$('#content_solucion').append('<div id="contenidoPOP">'+solucionTex+'</div>');
				});
				
				
				var tS = 0;
				$("#clave1").click(function() {

					if (tS == 0) {
				$("#content_solucion").width($("#content_solucion").width() );

						$('#content_solucion').jScrollPane({
							showArrows : false,
							hideFocus : true
						});
						tS++;
					}
					ims.interfaz.resize();
				});

			};

			$(config_xml).find("feedback").each(function() {
				var id = $(this).attr("idw");
				if (($("#" + id).hasClass("red")) || ($("#" + id).hasClass("green"))) {
					ims.interfaz.addPopup(id, id);
					

					var Tex = $(this).text();
					$('#content_' + id + '').append('<div id="contenidoPOP">'+Tex+'</div>');
					ims.interfaz.resize();

					$("#" + id).prepend("<div class='img_feedback sprite background'></div>");
					$("#"+id).click(function(){
						$("#content_" + id).width($("#content_" + id).width());

						$('#content_' + id).jScrollPane({
							contentWidth : 0,
							showArrows : false,
							hideFocus : true
						});
					});
				};
				$(".img_feedback").each(function() {
					$(this).css("margin-top", ($(this).parent().height() - $(this).height()) / 2);
				});
			});
			 if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
				if (numCorrect == numPregunta) {
					setTimeout(function() {
						ims.interfaz.playSound('rGood');
					}, 200);
				} else {
					setTimeout(function() {
						ims.interfaz.playSound('rBad');
					}, 200);
				};
            }
			if (ims.interfaz.skin == "musica") {
				ims.interfaz.showResults("" + numCorrect + " / " + numPregunta + "");
			} else {
				ims.interfaz.showResults("<p>" + numCorrect + " / " + numPregunta + "</p>");
			};
			ims.interfaz.disable("comprobar1");
			$("#comprobar1").unbind('click');

			if ( inmediastudio.TRAZA.guardarRespuesta ) 
        { 
            inmediastudio.RESULTADOS.guardarPuntuacion( numCorrect/numPregunta );
        }  
		} else {
			//alert("La actividad ya ha sido comprobada.");
		};
	} else {
		//alert("Marque una respuesta para realizar la comprobación.");
	};

};

function solucion() {
	if ($("#versolucion2").hasClass("notdisabled")) {
		ims.interfaz.disable("versolucion2");
		$(".resp").unbind('click');
		$(".stars").remove();
		$(".img_feedback").remove();
		$(config_xml).find("lang").find("ES").find("respuesta").each(function() {
			var id = $(this).attr("idw");
			var correcta = $(this).attr("val");
			$("#center").height(0).hide();
			$("#center").empty();

			if ((correcta == 0)) {
				$("#" + id).addClass("green");
				ims.interfaz.showStars($("#" + id));
			} else {
				$("#" + id).removeClass("red").removeClass("selected");
			};

			ims.interfaz.playSound('good');
		});
	};
};

function prevPage() {
	$(".stars").remove();
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	inicializar();
	retornar();
};

function nextPage() {
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	retornar();
};

function retornar(){
	introduce_retorno();
}

function reload() {
	$(".stars").remove();
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	if (!ims.interfaz.sound) {
		mute();
	};
	retornar();
};

function mute() {
	$('.tooltip').hide();
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar');
	$('#silenciar1').addClass('silenciar_on');
	$('#silenciar1').tooltip();
	ims.interfaz.bind("silenciar1", "play()");
	ims.interfaz.disableSound();
};

function play() {
	$('.tooltip').hide();
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar_on');
	$('#silenciar1').addClass('silenciar');
	$('#silenciar1').tooltip();
	ims.interfaz.bind("silenciar1", "mute()");
	ims.interfaz.enableSound();
};
function getRandomArray(min, max) {
	var A = [];
	while (max >= min)
	A.push(max--);
	A.sort(function() {
		return .5 - Math.random();
	});
	return A[0];
};