// var url_interfaz = "";
var url_files = "";

if (typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function(e) {
        init();
		window.addEventListener("scroll", posicionar, false);
		window.addEventListener("resize", posicionar, false);
		window.addEventListener("load", posicionar, false);
		if (isMobile)
			document.addEventListener("touchmove", preventMove(), false);
    });
}else{
	 $(window).ready(function(){
		 init();
	});
	$(window).resize(function(){
		posicionar();
	});
	$(window).load(function(){
		posicionar();
	});
	$(window).scroll(function(){
		posicionar();
	});
}

function preventMove(e) {
	e.preventDefault();
	return false;
};

function posicionar() {

	if ( $("#intro_text").html() == null ){
		if ( !$('#visor').hasClass("jspScrollable") ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}
	}
	else {
		if ( !$('#visor').hasClass("jspScrollable") ){
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});
		}

	}
	ims.interfaz.resize();
}


function init() {

	// if ($("#url_interfaz").text() != "") {
	// 	url_interfaz = $("#url_interfaz").text();
	// };
	$("#url_interfaz,.ui-page,.ui-loader").remove();

	config_xml = $.parseXML(config_xml);

	document.title = "Santillana";
	url_files = $(config_xml).find('path').text();
	
	ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
	ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
	ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
	ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');

	ims.interfaz.init();
	inmediastudio.TRAZA.init();

	if (isMobile) {

		$(".notdisabled").bind("touchstart", function() {
			$(this).addClass("active");
		}).bind("touchend", function() {
			$(this).removeClass("active");
		});
	};
	if ( typeof (editable) == "undefined" && $(config_xml).find("introduccion").find("texto1").text().length != 0) {
		inicializar();
	} else {
		cargar_actividad();
	};

};

function inicializar() {

	var IntTit = $(config_xml).find("palabras").find("introduccion").text();
	var IntTex = $(config_xml).find("introduccion").find("texto1").text();
	$("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');
	var comenzar = $(config_xml).find("comenzar").text();

	ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());

	$('#overall').hide();

	ims.interfaz.addButton("Siguiente", "right", "siguiente ", comenzar);
	ims.interfaz.enable("Siguiente");
	ims.interfaz.bind("Siguiente", 'nextPage()');
	posicionar();
    introduce_retorno();
};

function cargar_actividad() {
	loadContent();
	
	$(config_xml).find("pregunta").each(function() {

		
		var respuesta = '';

		$(this).find("respuesta").each(function() {
			var id = $(this).attr("id");
			var caracter = $(this).attr("caracter");
			respuesta += '<div id="' + id + '" class="respuesta"><div class="redondo"><span>' + caracter + '</span></div>' + $(this).text() + '<div style="clear: both;"></div></div>';
		});
		$("#visor").append(respuesta);

		$(config_xml).find("respuesta").each(function() {
			var id = $(this).attr("id");
			// test simple
			ims.interfaz.bind(id, 'marcar(' + id + ')');

		});
	});
	bindClick();
	posicionar();
	document.addEventListener("load",function(){
		$(".redondo").each(function() {
			if ($(this).next("p").outerHeight() > $(this).outerHeight()) {
				$(this).css("margin-top", ($(this).parent().height() - $(this).height()) / 2);
			} else {
				$(this).next("p").css("padding-top", ($(this).height() - $(this).next("p").height()) / 2);
			}
		});
	},false)
	
	// $("#carcasa").height($("#carcasa").height()-$("#header").height()-10).children().height($("#carcasa").height());
};
function loadContent() {
	var titulo = $(config_xml).find("introduccion").find("titulo").text();
	var enunciado = $(config_xml).find("enunciado").text();

	ims.interfaz.setTitle(titulo);

	$("#pregunta").append(enunciado);

	if ($(config_xml).find("pregunta").find("foto").length != 0) {
		var foto_object = $(config_xml).find("pregunta").find("foto");
		var foto = foto_object.text();
		var rotation = foto_object.attr("rotation");
		var width = foto_object.attr("width");
		var height = foto_object.attr("height");
		var x = foto_object.attr("x");
		var y = parseInt(foto_object.attr("y"));

		console.log( y );
		if ( !showHeader ){
			y = y - HEADER_HEIGHT;
		}
		console.log( y );
			
		if (foto != '') {

			if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
				var ieversion = new Number(RegExp.$1);

				if (ieversion >= 8) {
					if (url_files != "") {
						foto = url_files + foto;
					} else {
						foto = "fotos/" + foto;
					};
					$("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
					if (x == "" && y == "") {

						height = parseInt($('#fondo div img').height());
						width = parseInt($('#fondo div img').width());

						if (width < $("#fondo").width() || height < $("#fondo").height()) {
							x = $("#fondo").offset().left + $("#fondo").width() - width;
							y = $("#fondo").offset().top + $("#fondo").height() - height;
							$('#fondo div img').css({
								"margin-left" : x + "px ",
								"margin-top" : +y + "px"
							});
						};

					};
				};
			} else {
				if (url_files != "") {
					$('#fondo').css("background-image", "url(" + url_files + foto + ")");
				} else {
					$('#fondo').css("background-image", "url(fotos/" + foto + ")");
				};
				$('#fondo').css("background-repeat", "no-repeat");
				if (rotation != '') {
					$('#fondo').css("-webkit-transform", 'rotate( '+rotation+ 'deg)');
					if (x != '' || y != '') {
						//DRR 29/05/14 d.C
						//$('#fondo').css("background-position", x + "px " + y + "px");

						if (width != '' && height != '') {
							$('#fondo').css("background-size", width + "px " + height + "px");
						} else {
							if (height != '') {
								$('#fondo').css("background-size", "auto " + height + "px");
							} else {
								if (width != '') {
									$('#fondo').css("background-size", width + "px auto");
								};
							};
						};

					};
				};
			};

			url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
			bgImg = $('<img />');
			bgImg.hide();

			if (x == "" && y == "") {

				bgImg.bind('load', function() {
					height = parseInt($(this).height());
					width = parseInt($(this).width());
					if (width < $("#fondo").width() || height < $("#fondo").height()) {
						x = $("#fondo").offset().left + $("#fondo").width() - width;
						y = $("#fondo").offset().top + $("#fondo").height() - height;
						$('#fondo').css("background-position", x + "px " + y + "px");
					};

					bgImg.remove();
				});
			};
			$('#fondo').append(bgImg);
			bgImg.attr('src', url);
			$('#fondo img').load(function(){
				$('#fondo').css({'width':foto_object.attr("width"),'height':foto_object.attr("height")});
			});
			$('#fondo').css({'top':y+'px','left':x+'px'});
		};
	};

	var silenciar = $(config_xml).find("silenciar").text();
	var ayuda = $(config_xml).find("palabras").find("ayuda").text();
	var comprobar = $(config_xml).find("comprobar").text();
	var clave = $(config_xml).find("desarrollo").text();
	var imprimir = $(config_xml).find("imprimir").text();
	var versolucion = $(config_xml).find("versolucion").text();
	var reiniciar = $(config_xml).find("reiniciar").text();

	var volver = $(config_xml).find("volver").text();

	if (!isMobile){
		ims.interfaz.addButton("silenciar", "left", "silenciar", silenciar);
	}

	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.addButton( "pausar", "left", "pause", $(config_xml).find("pausa").text());
	  	ims.interfaz.addButton( "player", "left", "play", $(config_xml).find("reproducir").text());
	}
	if (!isMobile && $(config_xml).find("urlimprimir").text().length>0)
		ims.interfaz.addButton("imprimir", "left", "imprimir", imprimir);
	ims.interfaz.addButton("Anterior", "left", "anterior", volver);
	 
	if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {
		ims.interfaz.enable("Anterior");
		ims.interfaz.bind("Anterior", 'prevPage()');
	};

	ims.interfaz.addButton("ayuda", "right", "ayuda", ayuda);
	ims.interfaz.addButton("comprobar", "right", "comprobar", comprobar);
	ims.interfaz.addButton("versolucion", "right", "versolucion", versolucion);
	ims.interfaz.addButton("clave", "right", "clave", clave);
	
	ims.interfaz.addButton("reiniciar","right", "reiniciar", reiniciar);

		ims.interfaz.enable("silenciar");

	if (ims.interfaz.sound) {
		ims.interfaz.bind("silenciar", "mute()");
	} else {
		ims.interfaz.bind("silenciar", "play()");
	};
	if ($(config_xml).find("ayuda").find("texto1").text().length != 0) {
		ims.interfaz.addPopup("ayuda", "ayuda");
			var ayudaTit = $(config_xml).find("ayuda").find("titulo").text();
			var ayudaTex = $(config_xml).find("ayuda").find("texto1").text();
			$('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
			$('#content_ayuda').append('<div id="contenidoPOP">'+ayudaTex+'</div>');
ims.interfaz.resize();
	};

	ims.interfaz.bind("reiniciar", 'reload()');
	ims.interfaz.bind("comprobar", 'comprobar()');
	ims.interfaz.bind("imprimir", "imprimir()");
	ims.interfaz.enable("reiniciar");
	ims.interfaz.enable("comprobar");
	ims.interfaz.enable("imprimir");

	$("#overall").remove();
}
function bindClick(){
	

	var s = 0;
	$("#ayuda").click(function() {
		if (s == 0) {
			$("#content_ayuda").width($("#content_ayuda").width());

			$('#content_ayuda').jScrollPane({
				showArrows : false,
				hideFocus : true
			});
			s++;
		}
	});
}
function marcar(id) {
	if ($("#comprobar").hasClass("notdisabled")) {

		$(".selected").removeClass("selected");
		$("#respuesta").removeData("respuesta", id);
		$("#respuesta").data("respuesta", id);
		$("#" + id).addClass("selected");
		ims.interfaz.playSound('beep_select');
	};
};

function imprimir() {
		window.open($(config_xml).find("urlimprimir").text(), "Santillana", 'width=800,height=600');
};

function comprobar() {

	var puntuacion = 0;

	if ($(".respuesta").hasClass("selected")) {
		if ($("#comprobar").hasClass("notdisabled")) {

			$(".respuesta").unbind('click');

			var aciertos = "";
			if ( inmediastudio.TRAZA.mostrarSolucion ) 
            { 
				ims.interfaz.bind("versolucion", "solucion()");
				ims.interfaz.enable("versolucion");
            }
			else
			{
				$("#reiniciar").unbind('click');
				$("#reiniciar").removeClass("notdisabled");
				$("#Anterior").unbind('click');
				$("#Anterior").removeClass("notdisabled");
			}
			ims.interfaz.disable("comprobar");
			$("#comprobar").unbind('click');

			if ($(config_xml).find("ES > solucion").find("texto1").text().length != 0) {
				if ( inmediastudio.TRAZA.mostrarSolucion ) 
	            { 
					ims.interfaz.enable("clave");
					ims.interfaz.addPopup("solucion", "clave");
	            }

				var tS = 0;
				$("#clave").click(function() {

					if (tS == 0) {
				$("#content_solucion").width($("#content_solucion").width() );

						$('#content_solucion').jScrollPane({
							showArrows : false,
							hideFocus : true
						});
						tS++;
					ims.interfaz.resize();

					}
				});

				$(config_xml).find("ES > solucion").each(function() {
					var solucionTit = $(this).find("titulo").text();
					var solucionTex = $(this).find("texto1").text();
					$('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
					$('#content_solucion').append('<div id="contenidoPOP">'+solucionTex+'</div>');
				});
			};

			$(config_xml).find("respuesta").each(function() {

				var id = $(this).attr("id");
				var correcta = $(this).attr("val");
				if ((correcta == "0") && (id == $(".selected").attr("id"))) {
					if ( inmediastudio.TRAZA.mostrarSolucion ) 
		            { 
						$(".selected").addClass("green");
						ims.interfaz.showStars($("#" + id));
		            }
		            puntuacion++;
				} else {
					if ( inmediastudio.TRAZA.mostrarSolucion ) 
					{ 
						$(".selected").addClass("red");
					}
				};

				$(config_xml).find("feedback").each(function() {

					if (id == $(this).attr("id")) {

						if (($("#" + id).hasClass("red")) || ($("#" + id).hasClass("green"))) {

							$("#" + id).addClass("feedbacked");
							
								$("#" + id).prepend("<div class='img_feedback sprite background'></div>");
							

							ims.interfaz.addPopup(id, id);

							$('#content_' + id).html('<div id="contenidoPOP">'+$(this).text()+'</div>');

					
				$("#"+id).click(function(){
						$("#content_" + id).width($("#content_" + id).width());

						$('#content_' + id).jScrollPane({
							contentWidth : 0,
							showArrows : false,
							hideFocus : true
						});
					});
					ims.interfaz.resize();
							

						};

					};

				});
				$(".img_feedback").each(function() {
					$(this).css("margin-top", ($(this).parent().height() - $(this).height()) / 2);
				});
			});

			if ( puntuacion == 1 ) {
				aciertos = "<p> 1 / 1 </p>";
				if ( inmediastudio.TRAZA.mostrarSolucion ) 
	            { 
					ims.interfaz.playSound('rGood');
	            }
				ims.interfaz.showResults(aciertos);
			} else {
				aciertos = "<p> 0 / 1 </p>";

				if ( inmediastudio.TRAZA.mostrarSolucion ) 
	            { 
					ims.interfaz.playSound('rBad');
	            }
				ims.interfaz.showResults(aciertos);
			};
			if ( inmediastudio.TRAZA.guardarRespuesta ) 
	        { 
	            inmediastudio.RESULTADOS.guardarPuntuacion( puntuacion );
	        }  
			
		};
	};
};

function solucion() {
	if ($("#versolucion").hasClass("notdisabled")) {
		$(".selected").removeClass("selected");
		ims.interfaz.disable("versolucion");
		$(".stars").remove();
		$(config_xml).find("respuesta").each(function() {
			var id = $(this).attr("id");
			var correcta = $(this).attr("val");
			$(".img_feedback").remove();
			$(".red").removeClass("red");
			$(".feedbacked").unbind('click');
			$(".feedbacked").removeClass('feedbacked');
			$("#center").hide();
			$("#center").empty();
			if ((correcta == 0)) {
				$("#" + id).addClass("green");
				ims.interfaz.showStars($("#" + id));

			};
		});
		ims.interfaz.playSound('good');
	};
};

function prevPage() {
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	inicializar();
	retornar();
};

function nextPage() {
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	retornar();
};

function retornar(){
	introduce_retorno();
}

function reload() {
	$(".stars, .tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	if (!ims.interfaz.sound) {
		mute();
	};
	retornar();
};

function mute() {
	$('.tooltip').hide();
	$('#silenciar').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar').removeClass('silenciar');
	$('#silenciar').addClass('silenciar_on');
	if (!isMobile) {
		$('#silenciar').tooltip();
	}
	ims.interfaz.bind("silenciar", "play()");
	ims.interfaz.disableSound();
};

function play() {
	$('.tooltip').hide();
	$('#silenciar').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar').removeClass('silenciar_on');
	$('#silenciar').addClass('silenciar');
	if (!isMobile) {
		$('#silenciar').tooltip();
	}
	ims.interfaz.bind("silenciar", "mute()");
	ims.interfaz.enableSound();
};