/*

    Autor: Daniel Rodríguez Ramírez
    Fecha: 2013 d.C

*/
var checked        = 0;
var p              = 2;
var dragging       = false;
var draggingObj    = null;
var soluciones     = new Array();
var xMouse         = 0;
var yMouse         = 0;
var boxHeight      = 67;
var imageBck       = "sec_";
// var url_interfaz   = "";
var url_files      = "";
var iniWidth       = 0,
    iniHeight      = 0;
var reinicio       = [];
var todas_palabras = [];
var palabras       = ''; //5 para las palabras de quinto, 6 para las de sexto, etc.

var posicionar = function () {
    ims.interfaz.resize();
    var _this = $("#image");
    var imageWidth = parseInt(_this.outerWidth());
    var imageHeight = parseInt(_this.outerHeight());
    if($('.positionbar').length == 0) {
        $("#visor").height($("#carcasa").height() - $('#header').height() - parseInt($('#header').css('padding-top')) - $('#bottombar').height());
    }else{
        $("#visor").height($("#carcasa").height() - $('#header').height() - parseInt($('#header').css('padding-top')));
    }
};


$(document).ready(function () {
    // if($("#url_interfaz").text() != "") {
    //     url_interfaz = $("#url_interfaz").text();
    // }
    $("#url_interfaz").remove();

    config_xml = $.parseXML(config_xml);
    url_files = $(config_xml).find("path").text();
    ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    ims.interfaz.setSound('bad', url_interfaz + 'audio/bad.mp3');
    ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');
    ims.interfaz.init();
    if(isMobile) {
        document.addEventListener("touchmove", function (e) {
            e.preventDefault();
            return false;
        }, false);
        if(isiOS) {
            $("body").css("margin-top", "-20px");
        }
        $(".notdisabled").bind("touchstart", function () {
            $(this).addClass("active");
        }).bind("touchend", function () {
            $(this).removeClass("active");
        });
    }
    if(typeof (editable) != "undefined") {
        cargar_actividad();
    }else{
        if(navigator.appName === 'Microsoft Internet Explorer') {
            inicializar();
        }
    }
    $("#overall").remove();
});


if(typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function (e) {
        inicializar();
        window.addEventListener("resize", posicionar, false);
        window.addEventListener("load", posicionar, false);
        if(isMobile) {
            window.addEventListener('DOMContentLoaded', preventMove(e), false);

        }
    });
}else{
    $(window).ready(function () {
        inicializar();
    });
    $(window).resize(function () {
        posicionar();
    });
    $(window).load(function () {
        posicionar();
    });
    $(window).scroll(function () {
        posicionar();
    });
}

function preventMove(e) {
    e.preventDefault();
    return false;
}


$(window).resize(function () {
    if(ims.interfaz.getSkin() == "tablet")
        scroll();
});

function scroll() {
    if($("#intro_text").html() == null) {
        $('#visor').height($("#content").height() - 60);
        // $('#visor').width($('#visor').width()).children().width($('#visor').width());
    }
    else{
        $('#visor').width($('#content').width() + 40);
        $('#visor').height($('#content').height() - 60);
        $('#visor').jScrollPane({
            contentWidth: 0,
            horizontalGutter: -30,
            verticalGutter: -30,
            autoReinitialise: true
        });
    }
}

function inicializar() {
    if($(config_xml).find("introduccion").find("texto1").text().length != 0) {
        var IntTit = $(config_xml).find("introduccion").find("titulo").text();
        var IntTex = $(config_xml).find("introduccion").find("texto1").text();
        $("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');
        var comenzar = $(config_xml).find("comenzar").text();
        scroll();
        if($.browser.msie && $.browser.version.slice(0, 1) == "8") {
            if(ims.interfaz.skin == "musica") {
                $("#limit").css({
                    "border": "2px solid #CCCCCC"
                });
            }
        }
        ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());
        ims.interfaz.enable("Siguiente");
        ims.interfaz.bind("Siguiente", 'nextPage()');
    }else{
        cargar_actividad();
    }
    scroll();
}

function marcar(id) {
    if($("#comprobar1").hasClass("notdisabled")) {
        $(".selected").removeClass("selected");
        $("#respuesta").removeData("respuesta", id);
        $("#respuesta").data("respuesta", id);
        $("#" + id).addClass("selected");
        ims.interfaz.playSound('beep_select');
    }
}

function imprimir() {
    window.open($(config_xml).find("urlimprimir").text(), "Santillana", 'width=800,height=600');
}

function reload() {}

function cargar_actividad() {
    $(".ui-loader,.ui-page").remove();
    document.title = 'Santillana';
    $(config_xml).find("pregunta").eq(0).each(function () {
        var reiniciar = $(config_xml).find("reiniciar").text();
        var comprobar = $(config_xml).find("comprobar").text();
        var visualizar = $(config_xml).find("visualizar").text();
        var solucionar = $(config_xml).find("versolucion").text();
        var aleatorio = $(config_xml).find("aleatorio").text();
        var silenciar = $(config_xml).find("silenciar").text();
        if(!isMobile) {
            ims.interfaz.addButton("silenciar1", "left", "silenciar", silenciar);
        }
        ims.interfaz.addButton("comprobar4", "right", "comprobar", comprobar);
        ims.interfaz.addButton("versolucion2", "right", "versolucion", solucionar);
        ims.interfaz.addButton("aleatorio", "right", "aleatorio", aleatorio);
        ims.interfaz.addButton("reiniciar4", "right", "reiniciar", reiniciar);
        ims.interfaz.enable("aleatorio");
        ims.interfaz.bind("aleatorio", 'aleatorio()');
        ims.interfaz.enable("reiniciar4");
        ims.interfaz.bind("reiniciar4", 'reiniciar()');
        //añadir boton icon de mostrar/ocultar la orden 
        orden = $(config_xml).find('orden').text() != '' ? $(config_xml).find('orden').text() : 'Orden';
        ims.interfaz.addButton("orden1", "left", "orden", orden);
        ims.interfaz.bind("orden1", "toggle_enunciado()");
        ims.interfaz.enable("orden1");
        //asignar al p dentro del enunciado la clase pregunta_inf que le pone el borde rojo
        $('#pregunta').addClass('pregunta_inf');
        // $('#pregunta').css('position', 'absolute');
        // Enunciados respuestas y caracteres
        var enunciado = $(this).find("enunciado").text();
        var respuesta = '';
        $(this).find("respuesta").each(function () {
            var id = $(this).attr("id");
            var caracter = $(this).attr("caracter");
            respuesta += '<div id="' + id + '" class="respuesta"><div class="redondo"><span>' + caracter + '</span></div>' + $(this).text() + '<div style="clear: both;"></div></div>';
        });
        ims.interfaz.setTitle($(this).find("titulo").text());
        if(enunciado != '') {
            $('#pregunta').append(enunciado.replace(/<br>/g, ""));
        }else{
            $('#pregunta').remove();
            $('#orden1').remove();
        }
        if($(config_xml).find("variable").text() == '5') {
            palabras = 'palabras_quinto';
        }
        if($(config_xml).find("variable").text() == '6') {
            palabras = 'palabras_sexto';
        }
        // Metemos la capa contenedora
        $('#visor').append('<div id="contenedora"></div>');
        $('#contenedora').append('<div id="contenido"></div>');
        nuevas_palabras();
        $('.cajita').live('click', function () {
            if($(this).attr('class') == 'caja_iz cajita' || $(this).attr('class') == 'caja_de cajita')
                if($(this).parent().find('.pulsado').length == 0) {
                    if($(this).attr('class') == 'caja_iz cajita') {
                        $(this).next().remove();
                        $(this).transition({
                            x: $('.caja_palabra').width() / 2 - $(this).width() / 2 - 10 - 25
                        });
                    }else{
                        $(this).prev().remove();
                        $(this).transition({
                            x: -$('.caja_palabra').width() / 2 + $(this).width() - 10 + 25
                        });
                    }
                    $(this).addClass('pulsado');
                }
                //Comprobamos si están los 3 pulsados para activar el comprobar
            var pul = 0;
            $('.pulsado').each(function () {
                pul++;
            });
            if(pul == 3) {
                a_comprobar();
            }
        });
        // Imagen de fondo
        if($(config_xml).find("pregunta").find("foto").length != 0) {
            var foto_object = $(config_xml).find("pregunta").find("foto");
            var foto = foto_object.text();
            var rotation = foto_object.attr("rotation");
            var width = foto_object.attr("width");
            var height = foto_object.attr("height");
            var x = foto_object.attr("x");
            var y = parseInt(foto_object.attr("y"));
            if(foto != '') {
                if(/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
                    var ieversion = new Number(RegExp.$1);
                    if(ieversion >= 8) {
                        if(url_files != "") {
                            foto = url_files + foto;
                        }else{
                            foto = url_files + foto;
                        }
                        $("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
                        if(x == "" && y == "") {
                            height = parseInt($('#fondo div img').height());
                            width = parseInt($('#fondo div img').width());
                            if(width < $("#fondo").width() || height < $("#fondo").height()) {
                                x = $("#fondo").offset().left + $("#fondo").width() - width;
                                y = $("#fondo").offset().top + $("#fondo").height() - height;
                                $('#fondo div img').css({
                                    "margin-left": x + "px ",
                                    "margin-top": +y + "px"
                                });
                            }
                        }
                    }
                }else{
                    if(url_files != "") {
                        $('#fondo').css("background-image", "url(" + url_files + foto + ")");
                    }else{
                        $('#fondo').css("background-image", "url("+url_files + foto + ")");
                    }
                    $('#fondo').css("background-repeat", "no-repeat");
                    if (rotation != '') {
						$('#fondo').css("rotation", rotation);
					}	
					if (x != '' || y != '') {
						$('#fondo').css("background-position", x + "px " + y + "px");
					}	
					if (width != '' && height != '') {
						$('#fondo').css("background-size", width + "px " + height + "px");
					} else {
						if (height != '') {
							$('#fondo').css("background-size", "auto " + height + "px");
						} else {
							if (width != '') {
								$('#fondo').css("background-size", width + "px auto");
							}
						}
					}
                }
                url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
                bgImg = $('<img />');
                bgImg.hide();
                if(x == "" && y == "") {
                    bgImg.bind('load', function () {
                        height = parseInt($(this).height());
                        width = parseInt($(this).width());
                        if(width < $("#fondo").width() || height < $("#fondo").height()) {
                            x = $("#fondo").offset().left + $("#fondo").width() - width;
                            y = $("#fondo").offset().top + $("#fondo").height() - height;
                            $('#fondo').css("background-position", x + "px " + y + "px");
                        }
                        bgImg.remove();
                    });
                }
                $('#fondo').append(bgImg);
                $('#contenedora').css('background','none');
                bgImg.attr('src', url);
            }
        }
        if($(config_xml).find("introduccion").find("texto1").text().length != 0) {
            ims.interfaz.enable("Anterior");
            ims.interfaz.bind("Anterior", 'prevPage()');
        }
        if(ims.interfaz.sound) {
            ims.interfaz.enable("silenciar1");
            ims.interfaz.bind("silenciar1", "mute()");
        }else{
            ims.interfaz.bind("silenciar1", "play()");
        }
        $(config_xml).find("respuesta").each(function () {
            var id = $(this).attr("id");
            // test simple
            ims.interfaz.bind(id, 'marcar(' + id + ')');
        });
        ims.interfaz.resize();
    });
    if($.browser.msie && $.browser.version.slice(0, 1) == "8") {
        if(ims.interfaz.skin == "musica") {
            $("#limit").css({
                "border": "2px solid #CCCCCC"
            });
        }
    }
    var tA = 0;
    scroll();
}

function mute() {
    $('.tooltip').hide();
    $('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar1').removeClass('silenciar');
    $('#silenciar1').addClass('silenciar_on');
    if(!isMobile) {
        $('#silenciar1').tooltip();
    }
    ims.interfaz.bind("silenciar1", "play()");
    ims.interfaz.disableSound();
}

function play() {
    $('.tooltip').hide();
    $('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar1').removeClass('silenciar_on');
    $('#silenciar1').addClass('silenciar');
    if(!isMobile) {
        $('#silenciar1').tooltip();
    }
    ims.interfaz.bind("silenciar1", "mute()");
    ims.interfaz.enableSound();
}

function nohacernada() {}

function a_comprobar() {
    ims.interfaz.enable("comprobar4");
    ims.interfaz.bind("comprobar4", 'comprobar()');
}

function d_comprobar() {
    ims.interfaz.disable("comprobar4");
    ims.interfaz.bind("comprobar4", 'nohacernada()');
}

function a_solucionar() {
    ims.interfaz.enable("versolucion2");
    ims.interfaz.bind("versolucion2", 'solucionar()');
}

function d_solucionar() {
    ims.interfaz.disable("versolucion2");
    ims.interfaz.bind("versolucion2", 'nohacernada()');
}

function a_reiniciar() {
    ims.interfaz.enable("reiniciar4");
    ims.interfaz.bind("reiniciar4", 'reiniciar()');
}

function d_reiniciar() {
    ims.interfaz.disable("reiniciar4");
    ims.interfaz.bind("reiniciar4", 'nohacernada()');
}

function d_aleatorio() {
    ims.interfaz.disable("aleatorio");
    ims.interfaz.bind("aleatorio", 'nohacernada()');
}

function desordenar_array(bar) {
    var m = bar.length - 1;
    for(var i = m; i > 1; i--) {
        alea = Math.floor(i * Math.random());
        temp = bar[i];
        bar[i] = bar[alea];
        bar[alea] = temp;
    }
    return(bar);
}

function nuevas_palabras(variable) {
    d_reiniciar();
    d_solucionar();
    $('#palabras').remove();
    //Contenedora de las palabras
    $('#contenido').append('<div id="palabras"></div>');
    //Si generamos al reiniciar lo hacemos de otra forma (else)
    if(typeof (variable) == 'undefined') {
        //Metemos los eqs de las palabras en un array y lo desordenamos
        var array_palabras = [];
        var i = 0;
        $(config_xml).find(palabras).find("palabra").each(function () {
            array_palabras[i] = i;
            i++;
        });
        array_palabras = desordenar_array(array_palabras);
        todas_palabras = array_palabras;
        //Si solo podemos formar un trio de palabras desactivamos el botón
        if(todas_palabras.length < 6) {
            d_aleatorio();
        }
        //Recorremos las palabras y mostramos sólo 3
        for (var i=0; i<3; i++){
            $('#palabras').append('<div class="caja_palabra"><div class="palabra" id="eq'+array_palabras[0]+'">'+$(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).text()+'</div></div>');
            var aleatorio=Math.floor(Math.random() * (1-0+1)) + 0;
            if (aleatorio == 0){
                $('.caja_palabra:last').append('<div id="caja'+i+'" class="caja_iz cajita">'+$(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('bien')+'</div><div id="caja'+i+'" class="caja_de cajita">'+$(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('mal')+'</div>');
            }else{
                $('.caja_palabra:last').append('<div id="caja'+i+'b" class="caja_iz cajita">'+$(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('mal')+'</div><div id="caja'+i+'" class="caja_de cajita">'+$(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('bien')+'</div>');
            }
            var cadena = $('.palabra:last').text().replace($(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('bien'),' * ');
            posi   = parseInt($(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).attr('posi'));
            //Por si está la letra que se quiere cambiar repetida...
            if (!isNaN(posi)) {
                    cadena = replaceAt(($(config_xml).find(palabras).find("palabra").eq(array_palabras[0]).text()), posi, '*');
                    cadena = cadena.replace('*', ' <div class="reemplazo-asterisco">*</div> ');
                }
            $('.palabra:last').text(cadena);
           todas_palabras.shift();
        }
    }else{
        //Si estamos reiniciando
        if(typeof (variable) == 'object') {
            for(var i = 0; i < 3; i++) {
                $('#palabras').append('<div class="caja_palabra"><div class="palabra" id="eq' + variable[i] + '">' + $(config_xml).find(palabras).find("palabra").eq(variable[i]).text() + '</div></div>');
                var aleatorio = Math.floor(Math.random() * (1 - 0 + 1)) + 0;
                if(aleatorio == 0) {
                    $('.caja_palabra:last').append('<div id="caja' + i + '" class="caja_iz cajita">' + $(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('bien') + '</div><div id="caja' + i + '" class="caja_de cajita">' + $(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('mal') + '</div>');
                }else{
                    $('.caja_palabra:last').append('<div id="caja' + i + 'b" class="caja_iz cajita">' + $(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('mal') + '</div><div id="caja' + i + '" class="caja_de cajita">' + $(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('bien') + '</div>');
                }
                var cadena = $('.palabra:last').text().replace($(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('bien'), ' * ');
                posi = parseInt($(config_xml).find(palabras).find("palabra").eq(variable[i]).attr('posi'));
                //Por si está la letra que se quiere cambiar repetida...
                if(!isNaN(posi)) {
                    cadena = replaceAt(($(config_xml).find(palabras).find("palabra").eq(variable[i]).text()), posi, '*');
                    cadena = cadena.replace('*', ' <div class="reemplazo-asterisco">*</div> ');
                }
                $('.palabra:last').text(cadena);
            }
        }
        //Si pulsamos aleatorio
        var i = 0;
        if(typeof (variable) == 'string' && todas_palabras.length > 2) {
            $('.caja_palabra').remove();
            for(var i = 0; i < 3; i++) {
                $('#palabras').append('<div class="caja_palabra"><div class="palabra" id="eq' + todas_palabras[i] + '">' + $(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).text() + '</div></div>');
                var aleatorio = Math.floor(Math.random() * (1 - 0 + 1)) + 0;
                if(aleatorio == 0) {
                    $('.caja_palabra:last').append('<div id="caja' + i + '" class="caja_iz cajita">' + $(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('bien') + '</div><div id="caja' + i + '" class="caja_de cajita">' + $(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('mal') + '</div>');
                }else{
                    $('.caja_palabra:last').append('<div id="caja' + i + '" class="caja_iz cajita">' + $(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('mal') + '</div><div id="caja' + i + '" class="caja_de cajita">' + $(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('bien') + '</div>');
                }
                var cadena = $('.palabra:last').text().replace($(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('bien'), ' * ');
                posi = parseInt($(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).attr('posi'));
                //Por si está la letra que se quiere cambiar repetida...
                if(!isNaN(posi)) {
                    cadena = replaceAt(($(config_xml).find(palabras).find("palabra").eq(todas_palabras[i]).text()), posi, '*');
                    cadena = cadena.replace('*', ' <div class="reemplazo-asterisco">*</div> ');
                }
                $('.palabra:last').text(cadena);
                todas_palabras.shift();
            }
            //En el caso de que no haya más grupos de palabras desactivamos el botón aleatorio
            if(todas_palabras.length < 3) {
                //d_aleatorio();
                nuevas_palabras();
            }
        }
    }
}

//Función para cambiar posición de letra (por si está la letra que se quiere cambiar repetida)
function replaceAt (texto, index, character) {
    return texto.substr(0, index) + character + texto.substr(index + character.length);
};

function comprobar() {
    var comprobar = '';
    $('.pulsado').each(function () {
        //Tomamos el id de la palabra (el cual tiene el eq del xml) y lo usamos para encontrar la respuesta correcta en el xml
        var eq = $(this).parent().find('.palabra').attr('id').replace('eq', '');
		// FIX -
		//var palabra_xml = ($(config_xml).find(palabras).find("palabra").eq(eq).text()).replace('-','');
		var palabra_xml = ($(config_xml).find(palabras).find("palabra").eq(eq).text());
        // if($(this).text() == '-') {
            // var palabra_comp = $(this).parent().find('.palabra').text().replace(' * ', '');
        // }else{
            // var palabra_comp = $(this).parent().find('.palabra').text().replace(' * ', $(this).parent().find('.cajita').text());
        // }
        var palabra_comp = $(this).parent().find('.palabra').text().replace(' * ', $(this).parent().find('.cajita').text());
        if(palabra_comp == palabra_xml) {
            $(this).addClass('correcto');
            $(this).prev().text(palabra_xml);
        }else{
            $(this).addClass('incorrecto');
            comprobar = 'si';
        }
        $(this).removeClass('pulsado');
    });
    d_comprobar();
    if(comprobar == 'si') {
        ims.interfaz.playSound('bad');
        a_reiniciar();
        a_solucionar();
    }else{
        aplauso_estrella();
    }
}

function reiniciar() {
    $('.stars').remove();
    $('.cajita').remove();
    //Volvemos a dibujar las cajitas
    var i = 0;
    $('.caja_palabra').each(function () {
        var eq = $(this).find('.palabra').attr('id').replace('eq', '');
        reinicio[i] = eq;
        i++;
    });
    nuevas_palabras(reinicio);
}

function aleatorio() {
    $('.stars').remove();
    var aleatorio = 'si';
    nuevas_palabras(aleatorio);
}

function solucionar() {
    var i = 0;
    $('.caja_palabra').each(function () {
        var eq = $(this).find('.palabra').attr('id').replace('eq', '');
        //Ponemos el texto correcto
       // $('.palabra').eq(i).text(($(config_xml).find(palabras).find("palabra").eq(eq).text()).replace('-', ''));
        $('.palabra').eq(i).text(($(config_xml).find(palabras).find("palabra").eq(eq).text()));

        //Ponemos la letra correcta
        $('.cajita').eq(i).text($(config_xml).find(palabras).find("palabra").eq(eq).attr('bien'));
        i++;
    });
    $('.incorrecto').addClass('correcto');
    $('.incorrecto').removeClass('incorrecto');
    d_solucionar();
    aplauso_estrella();
}

function aplauso_estrella() {
    //Mostramos estrellitas
    $('.stars').remove();
    $(".cajita").each(function () {
        var id = $(this).attr("id");
        var _this = $(this);
        ims.interfaz.showStars($("#" + id));
        id = id + 1;
    });
    ims.interfaz.playSound('good');
}

function toggle_enunciado() {
    $('#pregunta').fadeToggle();
}