var ims;
var $;
// var url_interfaz;
var url_files;
var isiOS;

var idEscena = 0;
var i;
var json;
var config_json;
var cantidadEscenas;
var escenaActual;
var ordenEscenas;
var escenasResueltas = 0;

var posicionar = function(){

   ims.interfaz.resize();
   // $("#visor").height($("#carcasa").height());

};

$(document).ready(function() {

   ims.interfaz.resize();
});

var init = function() {

   ims.interfaz.disableIE();
   // if( $( "#url_interfaz" ).text() !== "" ) {
   //    url_interfaz = $( "#url_interfaz" ).text();
   // }
   
   $( "#url_interfaz" ).remove();

   ims.interfaz.init();
   inicializar();
   $( "#overall" ).remove();
   $( "#right2" ).remove();
   $( "#left2" ).remove();
   if ( ! document.addEventListener ) {
      document.attachEvent( "touchmove", function( e ) {
         return false;
      }, false );
   } else {
      document.addEventListener( "touchmove", function( e ) {
         return false;
      }, false );
   }
   if ( isiOS ){
      $( "body" ).css( "margin-top", "-20px" );
   }
};

if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener ) {
   window.addEventListener( 'DOMContentLoaded', function( e ) {
      init();
      window.addEventListener( "scroll", posicionar, false );
      window.addEventListener( "resize", posicionar, false );
      window.addEventListener( "load",  posicionar, false );
      ims.interfaz.resize();
   });
}else{
   $(window).ready(function(){
      init();
      ims.interfaz.resize();
   });
   $(window).resize(function(){
      posicionar();
   });
   $(window).load(function(){
      posicionar();
      
   });
   $(window).scroll(function(){
      posicionar();
   });
}

function inicializar() {
   console.log(json);
   config_json = $.parseJSON(json);
   url_files = config_json.path;
   cantidadEscenas = config_json.escenas.length;
   //console.dir(config_json);
   var titulo = config_json.textos.titulo;
   ims.interfaz.setTitle(titulo);

   var consigna = config_json.textos.enunciado;
   desplegarConsigna(consigna);
   cargar_herramienta();
}

function cargar_herramienta() {
   ordenEscenas = desordenarEscenas(cantidadEscenas);
   escenaActual = ordenEscenas[0];
   idEscena = ordenEscenas[0];
   desplegarEscena(escenaActual);
}

/**
 * despliega una escena
 * @@param int idEscena: numero de escenas 
 * @return bool
 */
function desplegarEscena(idEscena){
   if(!$.isNumeric(idEscena)) {
      idEscena = 0;
   }
   emptyStage();
   cargarCommonStage();
   $("#visor").append("<div id='wrapper'><div id='palabras-escena'><div>");
   $("#wrapper").append("<div id='ayuda-escena'></div>");
   $("#ayuda-escena").append("<div id='ayuda-escena-list'></div>");
   $("#wrapper").append("<div id=boton-ayuda>¿Necesitas ayuda?</div>");
   $( "#boton-ayuda" ).bind( "click", desplegarAyuda);
   desplegarImagen(idEscena);
   desplegarPalabras(obtenerPalabras(idEscena));
   return true;
}

/**
 * despliega la escena siguiente segun el array ordenEscenas
 * @@param  
 * @return bool
 */
function desplegarEscenaAleatoria(){
   escenasResueltas++;
   idEscena = ordenEscenas[escenasResueltas];
   desplegarEscena(ordenEscenas[escenasResueltas]);
   return true;
}

/**
 * recibe la cantidad de escenas cargadas y devuelve un array desordenado con enteros de 0 a cantidadEscenas
 * ej: 6 escenas retorna [3,5,0,1,2,4]
 * @@param int cantidadEscenas 
 * @return array
 */
function desordenarEscenas(cantidadEscenas){
   if(!$.isNumeric(cantidadEscenas)) {
      return false;
   }
   var array = new Array();
   for(i=0; i<cantidadEscenas;i++){
      array[i]=i;
   }   
   var currentIndex = array.length;
   var temporaryValue;
   var randomIndex;
   while (0 !== currentIndex) {
      randomIndex = Math.floor(Math.random() * currentIndex);
      currentIndex -= 1;
      temporaryValue = array[currentIndex];
      array[currentIndex] = array[randomIndex];
      array[randomIndex] = temporaryValue;
   }
  return array;
}

/**
 * inserta una imagen correspondiente a una escena en el placeholder
 * @@param int idEscena: numero de escenas 
 * @return bool
 */
function desplegarImagen(idEscena){

   var FIXPOSITION = 18;

   if(!$.isNumeric(idEscena)) {
      return false;
   }
   var pos_x = config_json.escenas[idEscena].pos_x; 
   var pos_y = config_json.escenas[idEscena].pos_y; 
   var img_width = config_json.escenas[idEscena].img_width; 
   var img_height = config_json.escenas[idEscena].img_height; 
   
   pos_x = (pos_x != null && pos_x != "") ?  parseInt(pos_x) : 110;
   pos_y = (pos_y != null && pos_y != "") ?  parseInt(pos_y) - parseInt( $("#header").height() ): 110 - parseInt($("#header").height());

   pos_y = pos_y - FIXPOSITION;

   $("#visor").append("<img src='" + url_files + config_json.escenas[idEscena].nombre_imagen +"'>");
   
   $('#visor img').css("left", pos_x + "px"); 
   $('#visor img').css("top", pos_y + "px"); 
   if(img_width != null && img_width != "") $('#visor img').css("width", img_width + "px");  
   if(img_height != null && img_height != "")  $('#visor img').css("height", img_height + "px"); 
   
   $('#visor img').css("position", "absolute");
   
   return true;
}

/**
 * inserta una serie de palabras en el placeholder
 * @@param array palabras: array de palabras 
 * @return bool
 */
function desplegarPalabras(palabras){
   if(palabras.length===0){
      return false;
   }
   for(i=0; i<palabras.length;i++){
      $("#palabras-escena").append("<div class='palabra' id='palabra_"+i+"'>"+palabras[i]+"</div>");
   }
   return true;
}

/**
 * obtiene las palabras correspondientes a una escena
 * @@param int idEscena: numero de escenas 
 * @return array
 */
function obtenerPalabras(idEscena){
//el requerimiento establece 6 palabras por escena. en el futuro podria variar
   if(!$.isNumeric(idEscena)) {
      return false;
   }
   var palabras = new Array();
   //for(i=0;i<config_json[idEscena].palabras.length;i++){
   for(i=0;i<config_json.escenas[idEscena].palabras.length;i++){
      palabras[i]=config_json.escenas[idEscena].palabras[i].palabra;
      //palabras[i]=config_json[idEscena].palabras[i].palabra;
   }
   return palabras;
}

/**
 * inserta la consigna de la herramienta en el placeholder
 * @@param string consigna 
 * @return bool
 */
function desplegarConsigna(consigna){
   if(consigna === '') {
      return false;
   }
   $("#pregunta").html(consigna);
   return true;
}

/**
 * despliega la ventana emergente con el cuestionario correspondiente a la escena
 * @@param
 * @return bool
 */
function desplegarAyuda(){
   $("#ayuda-escena-list").html(obtenerTextoAyuda());
   $('#ayuda-escena').fadeToggle();
   return true;
}

/**
 * obtiene el cuestionario de ayuda correspondiente a la escena
 * @@param
 * @return string
 */
function obtenerTextoAyuda(){
   return config_json.escenas[ordenEscenas[escenasResueltas]].cuestionario;
}

//quita los elementos presente y limpia el visor
// -------------------------------------------------------------------------
function emptyStage(){
   $('#visor img').remove();
   $("#palabras-escena").remove();
   $("#ayuda-escena").remove();
   $("#wrapper").remove();
   $("#right").empty();
   $("#left").empty();
   $(".tooltip").hide();
}

function reiniciar(){
   escenasResueltas = 0;
   ordenEscenas = desordenarEscenas(cantidadEscenas);
   desplegarEscena(escenaActual);
   desplegarEscena(ordenEscenas[0]);
}

//agrega los botones, los bindea y los habilita
// --------------------------------------------------------------
function cargarCommonStage(){
   var aleatorio = (config_json.textos.aleatorio !== "" ) ? config_json.textos.aleatorio : "Otra escena";
   var reiniciar = (config_json.textos.reiniciar !== "" ) ? config_json.textos.reiniciar : "Empezar de nuevo";
   ims.interfaz.addButton("aleatorio","right","aleatorio",aleatorio);
   ims.interfaz.addButton("reiniciar","right","reiniciar",reiniciar);
   ims.interfaz.bind("aleatorio","desplegarEscenaAleatoria()");
   if(escenasResueltas+1<cantidadEscenas){
      ims.interfaz.enable("aleatorio");   
   }else{
      $( "#aleatorio").unbind( "click" );
      ims.interfaz.bind("reiniciar","reiniciar()");
      ims.interfaz.enable("reiniciar");
   }
}


