var saltoPantalla1          = 0;
var saltoPantalla2          = 0;
var globalIdSubConjunto     = 0;
var globalIdConjunto        = 0;
var palabrasCorrectas       = [];
var url_files               = "";
var reEmpezar               = 0;
var random                  = 0;
var numeroPreguntaAleatoria = 0;

var posicionar = function () {
    ims.interfaz.resize();
    $("#visor").height($("#carcasa").height() - 60);
};

$(document).ready(function () {
    ims.interfaz.resize();
});

var init = function () {
    ims.interfaz.disableIE();
    // if($("#url_interfaz").text() !== "") {
    //     url_interfaz = $("#url_interfaz").text();
    // }
    $("#url_interfaz").remove();

    config_xml = $.parseXML(config_xml);
    url_files = $(config_xml).find("path").text();
    var Interfaz = $(config_xml).find("tipoInterfaz").text();
    var SubTipoInterfaz = $(config_xml).find("subTipoInterfaz").text();
    ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
    ims.interfaz.setSound('bad', url_interfaz + 'audio/bad.mp3');
    ims.interfaz.setSound('result', url_interfaz + 'audio/result.mp3');
    ims.interfaz.init();
    inicializar();
    $("#overall").remove();
    $("#right2").remove();
    if(!document.addEventListener) {
        document.attachEvent("touchmove", function (e) {
            return false;
        }, false);
    }else{
        document.addEventListener("touchmove", function (e) {
            return false;
        }, false);
    }
    if(isiOS) {
        $("body").css("margin-top", "-20px");
    }
};

if(typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
    window.addEventListener('DOMContentLoaded', function (e) {
        init();
        window.addEventListener("scroll", posicionar, false);
        window.addEventListener("resize", posicionar, false);
        window.addEventListener("load", posicionar, false);
    });
}else{
    $(window).ready(function () {
        init();
    });
    $(window).resize(function () {
        posicionar();
    });
    $(window).load(function () {
        posicionar();
    });
    $(window).scroll(function () {
        posicionar();
    });
}

function inicializar() {
    // compruebo si existe introduccion para lanzar la pagina principal, en caso
    // de que no, cargamos la actividad
    // alert( $( config_xml ).find( "langs" ).nodeName )
    if($(config_xml).find("introduccion").find("texto1").text().length !== 0) {
        $(config_xml).find("introduccion").each(
            function () {
                var IntTit = $(this).find("titulo").text();
                var IntTex = $(this).find("texto1").text();
                ims.interfaz.setTitle(IntTit);
                $("#visor_content").append(
                    "<div id=\"respuesta\" style=\" padding : 30px 0px; \">" + IntTex + "</div>");
                var comenzar = $(config_xml).find("comenzar").text();
                ims.interfaz.addButton("Siguiente", "right", "siguiente",
                    comenzar);
                ims.interfaz.enable("Siguiente");
                ims.interfaz.bind("Siguiente", 'nextPage()');
            });
    }else{
        cargar_actividad();
    }

    introduce_retorno();
}

function cargar_actividad() {
    $("#pregunta").remove();
    var numConjuntos = 0;
    var borrarConjuntos = 0;
    var numSubConjuntos = 0;
    var pantalla = 1;
    setTable();
}

// Autor RCBL
// funcionalidad del btn Volver a empezar
function getInterfaz_VolverEmpezar() {

    ims.interfaz.enableSound();
    reEmpezar = 1;
    setTable();
/*
    $('input').val('');
    $('input').removeAttr("disabled");
    $('input').removeClass("red_i");
    $('input').removeClass("green_i");
*/
}

// Autor RCBL
// funcionalidad del btn Volver a empezar
function getInterfaz_Aleatorio() {
    ims.interfaz.enableSound();
    reEmpezar = 0;
    setTable();
}

// Autor RCBL
// crea los conjuntos
function setTable() {
    emptyStage();
    cargarCommunStage();
    dataTotal = getVerbos();
    $('#overall').remove();
    if(reEmpezar === 0) {
        random = Math.floor((Math.random() * dataTotal.length));
        numeroPreguntaAleatoria = ranNumArray(4, (dataTotal[random].length - 1));
    }
    // Variables y propiedades
    var verbo = dataTotal[random][0]['nombreVerbo'];
    $("#visor").prepend(tableToInsert);
    // "Escribe la forma verbal que corresponde en cada caso";
    var tableToInsert = '';
    tableToInsert = tableToInsert + '<table id="tblGral" border="0" cellspacing="0" cellpadding="0">';
    tableToInsert = tableToInsert + '<tr id="r1"  class="blanco">';
    tableToInsert = tableToInsert + '<td id="r1-1" height="36" class=" ">' + verbo + '</td>';
    tableToInsert = tableToInsert + '<td id="r1-2" height="36"  class="cabecera">' + $(config_xml).find("persona").text() + '</td>';
    tableToInsert = tableToInsert + '<td id="r1-3" height="36"  class="cabecera">' + $(config_xml).find("numero").text() + '</td>';
    tableToInsert = tableToInsert + '<td id="r1-4" height="36"  class="cabecera">' + $(config_xml).find("tiempo").text() + '</td>';
    tableToInsert = tableToInsert + '</tr>';
    palabrasCorrectas = [];
    for(i = 2; i <= 6; i++) {
        palabrasCorrectas[(i - 2)] = dataTotal[random][numeroPreguntaAleatoria[(i - 2)]]['conjugacion'];
        nombreTiempo = $(config_xml).find("langs " + dataTotal[random][numeroPreguntaAleatoria[(i - 2)]]['tiempo']).text();
        tableToInsert = tableToInsert + '<tr id="r' + i + '">';
        tableToInsert = tableToInsert + '<td id="r-' + i + '-1" width="200" height="64" class="inputZoneBackGround"><input type="text" name="n' + (i - 2) + '" id="i' + (i - 2) + '" class="input" value="" autocomplete="off" /></td>';
        tableToInsert = tableToInsert + '<td id="r-' + i + '-2" width="130" height="64">' + dataTotal[random][numeroPreguntaAleatoria[(i - 2)]]['persona'] + '</td>';
        tableToInsert = tableToInsert + '<td id="r-' + i + '-3" width="130" height="64">' + dataTotal[random][numeroPreguntaAleatoria[(i - 2)]]['numero'] + '</td>';
        tableToInsert = tableToInsert + '<td id="r-' + i + '-4" width="190" height="64">' + nombreTiempo + '</td>';
        tableToInsert = tableToInsert + '</tr>';
    }
    tableToInsert = tableToInsert + '</table>';
    $("#visor_content").append(tableToInsert);
}

// Autor RCBL
// crea los subConjuntos
function getVerbos() {
    var data = new Array();
    data = [];
    a1 = 0;
    a2 = 0;
    $(config_xml).find("verbo").children().each(function (a) {
        if(this.nodeName == "id") {
            nombreVerbo = $(this).text();
        }else{
            data[a1] = [];
            $(this).children().each(function (b) {
                tiempo = this.nodeName;
                $(this).children().each(function (c) {
                    numero = $(config_xml).find("langs " + this.nodeName).text();
                    $(this).children().each(function (d) {
                        persona = $(config_xml).find("langs " + this.nodeName).text();
                        conjugacion = $(this).text();
                        data[a1][a2] = [];
                        data[a1][a2]["nombreVerbo"] = nombreVerbo;
                        data[a1][a2]["tiempo"] = tiempo;
                        data[a1][a2]["numero"] = numero;
                        data[a1][a2]["persona"] = persona;
                        data[a1][a2]["conjugacion"] = conjugacion;
                        a2++;
                    });
                });
            });
            a1++;
            a2 = 0;
        }
    });
    return data;
}

function ranNumArray(values, limit) {
    var numbers = new Array();
    if(limit === undefined || limit === null) {
        limit = 3;
    }
    if(values === undefined || values === null) {
        values = limit - 1;
    }
    var count = -1;
    while(numbers.length <= values) {
        var match = false;
        count++;
        var ran = Math.floor((Math.random() * limit) + 1);
        for(var x = 0; x <= numbers.length; x++) {
            if(ran == numbers[x]) {
                match = true;
                break;
            }
        }
        if(!match) {
            numbers[count] = ran;
        }else{
            count--;
        }
    }
    return numbers;
}

function emptyStage() {
    $("#center").height(0);
    $("#center").empty();
    $("#fondo").css("background", "");
    $("body").toggle(1);
    $("#header p").remove();
    //$( "#pregunta" ).remove();
    $("#visor_content").remove();
    $("#respuesta").empty();
    $("#right").empty();
    $("#left").empty();
    $('.tooltip').hide();
    $("body").toggle(1);
    $("#visor").append('<div id="visor_content" style="height: 495px; "></div>');
}

function cargarCommunStage() {
    ims.interfaz.setTitle($(config_xml).find("titulo").text());
$('#pregunta').remove();
    enunciado = $(config_xml).find("enunciado").text();
    $('#content').append('<div id="pregunta">'+enunciado+'</div>');
    $('#pregunta').addClass('pregunta_inf');
    $('#pregunta').css('position', 'absolute');

    var comprobar = $(config_xml).find("comprobar").text();
    var aleatorio = ($(config_xml).find("aleatorio").text() !== "") ? $(config_xml).find("aleatorio").text() : "";
    var versolucion = $(config_xml).find("versolucion").text();
    var reiniciar = $(config_xml).find("reiniciar").text();
  	var volver = $( config_xml ).find( "volver" ).text();
   
    if(volver !== '') {
        ims.interfaz.addButton("Anterior", "left", "anterior", volver);
    }
    $('#left2').remove();
    ims.interfaz.addButton("reiniciar4", "right", "reiniciar", reiniciar);
    ims.interfaz.addButton("aleatorio", "right", "aleatorio", aleatorio);
    ims.interfaz.addButton("versolucion2", "left", "versolucion", versolucion);
    ims.interfaz.addButton("comprobar1", "left", "comprobar", comprobar);
    ims.interfaz.bind("aleatorio", "getInterfaz_Aleatorio()");
    ims.interfaz.bind("comprobar1", 'comprobar()');
    ims.interfaz.bind("reiniciar4", 'getInterfaz_VolverEmpezar()');
    ims.interfaz.enable("reiniciar4");
    ims.interfaz.enable("comprobar1");
    ims.interfaz.enable("aleatorio");
    if(!isMobile) {
        ims.interfaz.addButton("silenciar", "left", "silenciar", ($(config_xml).find("silenciar").text() !== "") ? $(config_xml).find("silenciar").text() : "");
        ims.interfaz.bind("silenciar", 'mute()');
        ims.interfaz.enable("silenciar");
        if(ims.interfaz.sound) {
            ims.interfaz.enable("silenciar");
            ims.interfaz.bind("silenciar", "mute()");
        }else{
            ims.interfaz.bind("silenciar", "play()");
        }
    }
    //añadir boton icon de mostrar/ocultar la orden 
    orden = ($(config_xml).find('orden').text() != '') ? $(config_xml).find('orden').text() : '';
    ims.interfaz.addButton("orden1", "left", "orden", orden);
    ims.interfaz.bind("orden1", "toggle_enunciado()");
    ims.interfaz.enable("orden1");

    $(config_xml).find("respuesta").each(function () {
        var id = $(this).attr("id");
        // test simple
        ims.interfaz.bind(id, 'marcar(' + id + ')');
    });

}

// Autor RCBL
// comprueba las frases
function comprobar() {
    var aciertos = 0;
    var total = $('input').size();
    hayValores = 0;
    $('input').each(function (n) {
        if($(this).val() !== "") {
            hayValores = 1;
        }
    });
    if(hayValores == 1) {
        ims.interfaz.enable("versolucion2");
        ims.interfaz.bind("versolucion2", 'solucion()');
        $('input').each(function (n) {
            indice = $(this).attr('id').replace("i", "");
            if(palabrasCorrectas[indice] == $(this).val()) {
                $(this).addClass("green_i");
                aciertos++;
            }else{
                $(this).addClass("red_i");
            }
        });
        resultado = "<p> " + aciertos + " / " + total + " </p>";
        if(aciertos != total) {
            setTimeout(function () {
                ims.interfaz.playSound('bad');
            }, 200);
        }else{
            setTimeout(function () {
                ims.interfaz.playSound('good');
                // ims.interfaz.playSound( 'result' );
            }, 200);
        }
        $('input').each(function (n) {
            $(this).attr("disabled", "disabled");
        });
        if(ims.interfaz.skin == "primaria_3er") {
            $("#center").css("left", "235px");
        }
        ims.interfaz.disable("comprobar1");
        $("#comprobar1").unbind('click');
    }
}

function solucion() {
    $('input').each(function (n) {
        indice = $(this).attr('id').replace("i", "");
        $(this).val(palabrasCorrectas[indice]);
        $(this).addClass("green_i");
    });
    setTimeout(function () {
        ims.interfaz.playSound('good');
    }, 200);
    ims.interfaz.disable("versolucion2");
    $("#versolucion2").unbind('click');
}

function prevPage() {
    $("#center").height(0);
    $("#center").empty();
    $("#fondo").css("background", "");
    $("body").toggle(1);
    $("#header").empty();
    $("#pregunta").remove();
    $("#visor_content").empty();
    $("#respuesta").empty();
    $("#right").empty();
    $("#left").empty();
    $('.tooltip').hide();
    $("body").toggle(1);
    inicializar();
}

function nextPage() {
    $("body").toggle(1);
    $("#header").empty();
    $("#visor_content").empty();
    $("#right").empty();
    $('.tooltip').hide();
    $("body").toggle(1);
    cargar_actividad();
}

function reload() {
    $("body div").remove();
    ims.interfaz.init();
    $("#overall").remove();
    cargar_actividad();
    ims.interfaz.enableSound();
}

function mute() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar');
    $('#silenciar').addClass('silenciar_on');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "play()");
    ims.interfaz.disableSound();
}

function play() {
    $('.tooltip').hide();
    $('#silenciar').attr('title', $(config_xml).find("silenciar").text());
    $('#silenciar').removeClass('silenciar_on');
    $('#silenciar').addClass('silenciar');
    $('#silenciar').tooltip();
    ims.interfaz.bind("silenciar", "mute()");
    ims.interfaz.enableSound();
}

function toggle_enunciado() {
    $('#pregunta').fadeToggle();
}
