if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener) {
	window.addEventListener('DOMContentLoaded', function(e) {
		setTimeout(function(){
			
			ruta = $("#url_editable").text();
			rutaInterfaz = $("#urlInterfaz").text();
			tipo = $(config_xml).find("tipo").text();
			hots_class = "editable-hotedit";
			editable_class = 'editable';

			$("#fondo").css("background-image", "none");

			/*
			 *	Hacks especificos de la interfaz5
			 */
			$('#transcripcion').remove();
			$('#transcrip').remove();
			$('#left > #time').remove();
			$("#visor").height($("#carcasa").height() - 60);

			var header = '<div id="header" class="hackNojHandlerCss"></div>';
			$('#header').remove();
			$("#visor").prepend(header);
			$("#header").append('<div class="sprite background logo"></div>');
			
			if(logo !== undefined){
				$('.logo').css({
					"background": "url("+logo+".png) no-repeat scroll left top transparent",
					"background-size": "135px 35px"
				});	
			}
			//	Fin hacks

			$(".button_left,canvas,.row , .button_right , .item_marcar , .hot_marcar,#presentacion").remove();
			ims.interfaz.addButton("save", "right", "save", $(config_xml).find("palabras").find("guardar").text());
			ims.interfaz.bind("save", 'save()');
			ims.interfaz.enable("save");
			ims.interfaz.addButton("grid", "left", "grid", $(config_xml).find("palabras").find("grid").text());
			ims.interfaz.bind("grid", 'grid()');
			ims.interfaz.enable("grid");
			$('#save').css({
				'float' : 'right',
//				'padding-right' : '50px'
			});
			$('#grid').css({
				'float' : 'left',
//				'padding-left' : '50px'
			});

			var borderradius = "";
			switch(ims.interfaz.getSkin()) {
				case 'primaria':
				case 'primaria_3er':
					borderradius = "border-radius:60px;-webkit-border-radius:60px;-ms-border-radius:60px;-moz-border-radius:60px;";
					break;
				default:
					borderradius = "border-radius:0px;-webkit-border-radius:0px;-ms-border-radius:0px;-moz-border-radius:0px;";
			}

			var overall = '<div id="overall" style="position:absolute;"></div>';
			$("#overall").remove();
			$("#content").prepend(overall);
			$("#content").append("<div id='red' style='top:0px;pointer-events:none;" + borderradius + "background-image:url(" + ruta + "css/images/grid.png);background-size:20px 20px;background-position:0px 0px;background-repeat:repeat;width:" + $("#fondo").width() + "px;height:" + $("#fondo").height() + "px;position:absolute;display:none;opacity:0.5;'></div>");

			$(config_xml).find("elemento").each(function(c) {
				idMedia = ($(this).attr("idMedia"));
				if (idMedia == id_pantalla) {
					tipo = ($(this).attr("tipo"));
					if (tipo == 'imagen_video_audio') {
						ims.interfaz.setTitle($(this).text());
						imgSRC = $(this).attr("imgSRC"), vidSRC = $(this).attr("vidSRC");
						if ( typeof ($(this).attr("vidX")) != 'undefined') {
							vidX = $(this).attr("vidX");
						} else {
							vidX = 100;
						}
						if ( typeof ($(this).attr("vidY")) != 'undefined') {
							vidY = Math.round($(this).attr("vidY")) + $("#header").outerHeight() + $("hr").outerHeight();
						} else {
							vidY = 100;
						}
						if ( typeof ($(this).attr("vidW")) != 'undefined') {
							vidW = $(this).attr("vidW");
						} else {
							vidW = 100;
						}
						if ( typeof ($(this).attr("vidH")) != 'undefined') {
							vidH = $(this).attr("vidH");
						} else {
							vidH = 100;
						}
						$("#fondo").append("<img id='image' src='" + $("#url_arc").text() + imgSRC + "'/>");
						$("#fondo").css('z-index', 1);
						marcarhot = '<div posicion="-1" x="' + (Math.round(vidX) - vidW ) + '" y="' + ( Math.round(vidY) ) + '">VIDEO</div>';
						var id = 0;

						var y = Math.round(vidY);
						if (y <= 5)
							y = $("#header").outerHeight() + $("hr").outerHeight();

						var x = Math.round(vidX);

						var width = Math.round(vidW);
						if (width <= 5)
							width = 40;
						var height = Math.round(vidH);
						if (height <= 5)
							height = 40;

						$("#overall").append($(marcarhot).addClass(editable_class).addClass(hots_class).addClass("hot_marcar").addClass('editable-hotspot').css({
							position : "absolute",
							top : y + 'px',
							left : x + 'px',
							width : width + 'px',
							height : height + 'px',
							"transform" : "rotate(0deg)",
							"-ms-transform" : "rotate(0deg)",
							"-moz-transform" : "rotate(0deg)",
							"-webkit-transform" : "rotate(0deg)",
							"z-index" : 1
						}).attr('idw', idMedia).attr('id', 'hot_' + id).attr('rel', idMedia).attr('angle', 0));
						$("#hot_" + id).click(function() {
							$(this).toggleClass('clicked');
						});

					}
				}
			});

			$('#visor').css('top','-7px');
			$('#bottombar').css('top', '597px');
						
			var _this = $("#image");
			_this.bind('load', function() {
				
				var imageWidth = parseInt(_this.outerWidth());
				var imageHeight = parseInt(_this.outerHeight());
				if (imageWidth > imageHeight) {
					_this.css("width", $("#fondo").width() + "px").css("margin-top", ($("#fondo").outerHeight() - _this.height()) / 2 + "px");
				} else {
					_this.css("height", $("#fondo").height() + "px").css("margin-left", ($("#fondo").outerWidth() - _this.width()) / 2 + "px");
				}
			});
			$("#fondo").css("background",$(config_xml).find("config").attr("skinColor").replace("0x","#"));
			removeElementFromArray = function(e, tipo, data) {
				deselectAll();
			}
			crearItemEditable = function(Objeto) {
				var _this = Objeto, obj = Objeto.displayObject, numele = Objeto.id, tipo = "Elemento " + numele, elemento = $('<div id="item_' + numele + '" idw="' + obj.attr('idw') + '" />').addClass("editable-item"), texto = $('<span class="texto" />').html(tipo), aspa = $('<img/>').attr('id', 'borrarElemento_' + obj.attr('idw')).attr("src", ruta + "css/images/borrar.png").css("float", "right").height(20), editarObj = $('<img/>').attr("src", ruta + "css/images/editar.png").css("float", "right").height(20), ordenar = $('<img/>').attr("src", ruta + "css/images/fourarrow.png").addClass('handle').css("float", "right").height(20), ojo = $("<div />").css({
					background : "url(" + ruta + "css/images/ojo.png)",
					float : "left",
					"margin-right" : "10px",
					"margin-top" : "0px",
					width : "20px",
					height : "15px"
				});

				$(obj).css("position", "absolute").attr("id", "do_" + _this.id);

				aspa.bind("click", function(e, confirmed) {
					e.preventDefault();
					e.stopPropagation();
					if (!_this.blocked) {
						if (confirm('¿Esta seguro de que desea eliminar este elemento?')) {
							_this.displayObject.remove();
							_this.listItem.remove();
							switch(Objeto.type) {
								case 'hotspot':
									break;
								case 'fondo':
									break;
							}
						}
					}
				});

				ojo.bind("click", function(e) {
					e.preventDefault();
					e.stopPropagation();
					if (_this.visible) {
						$(this).css("background-position", "bottom");
						obj.css("display", "none");
						_this.visible = false;
					} else {
						$(this).css("background-position", "top");
						obj.css("display", "block");
						_this.visible = true;
					}
					if (this.selected)
						$(document).trigger('deselectAll');
				});

				switch(Objeto.type) {
					case 'hotspot':
						_this.position = 'editable-hotspots';
						if (obj.html() == "") {
							texto.html('HotSpot ' + numele);
						} else {
							texto.html('' + obj.html().substring(0, 25));
						}
						editarObj.addClass('editarHot').attr('id', 'editHot_' + obj.attr('idw'));
						obj.addClass("editable-" + obj.attr("c"));
						elemento.append(texto).append(ojo);
						break;
					case 'fondo':
						_this.position = 'editable-configuracion';
						texto.html('Fondo ' + obj.html());
						if (obj.attr('src') != undefined) {
							var imagen = $('<img />').attr('class', 'item' + ucfirst(Objeto.type)).attr("src", obj.attr('src')).height(40).width(40);
							ojo.css("margin-top", "10px");
							editarObj.css("margin-top", "10px");
							aspa.css("margin-top", "10px");
							elemento.append(imagen);
						} else {
							elemento.append(texto);
						}

						ojo.css("margin-top", "10px");
						elemento.append(ojo);
						break;
				}
				editarObj.bind('click', function(e) {
					e.stopPropagation();
					deselectAll();
					SelectbyID(_this.displayObject);
					_this.select();
					_select = _this;
					switch(Objeto.type) {
						case 'hotspot':
							idHot = this.id.replace('editHot_', '');
							editarHot(idHot);
							break;
						case 'poi':
							idPoi = this.id.replace('editPoi_', '');
							editarPoi(idPoi);
							break;
						case 'texto':
						case 'imagen':
							idElemento = this.id.replace('editElemento_', '');
							editarElemento(idElemento);
							break;
					}
				});
				elemento.bind("click", selectElemento);
				Objeto.listItem = elemento;

				return Objeto.listItem;
			}
			addHotsHeader = function() {
				var header_hots = $("<div />").attr("id", "editable-header-hotspots").addClass("editable-header").addClass('ui-state-default').css('font-weight', 'bold').text("VIDEO");
				$('#editable-itemList').append($("<div />").attr("id", "editable-hotspots").append(header_hots));

				var blockhot = $("<div />").css({
					"background" : "url(" + ruta + "css/images/block.png)",
					float : "left",
					cursor : "pointer"
				}).width(20).height(15);
				header_hots.append(blockhot);
				blockhot.click(blockhotFn);
			};
			addElementosHeader = function() {
			};
			addOthersHeaders = function() {
			};
			addElementoTexto = function(id, texto) {
			}
			addElementoImagen = function(id, src, width, height) {
			}
			addElementoFondo = function(src, width, height) {
			}
			addHotSpot = function(idw, nombre, src) {
				var _idd = getNextIdd();
				var _newdo = $('<div></div>').attr('id', 'do_' + _idd).attr('idw', idw).addClass('hot_marcar').addClass('editable').addClass('editable-hotedit').addClass(ims.interfaz.editable_class).css({
					position : "absolute",
					top : '100px',
					left : '100px',
					width : '50px',
					height : '50px'
				}).attr('posicion', '-1').attr('x', '100').attr('y', '100').attr('rel', idw).html(nombre);
				if (src != undefined) {
					_newdo.css({
						'background-image' : 'url("' + src + '")',
						'background-repeat' : 'no-repeat'
					});
				}
				_display = giveMeVarDisplay();
				$("#overall").append(_newdo);
				$('#do_' + _idd).click(setSelection);

				var Obj = new editableObjeto();
				Obj.setId(_idd);
				Obj.setDisplayObject(_newdo);
				Obj.setType();
				Obj.createItem();

				$("#editable-hotspots").append(Obj.listItem);
				_display = giveMeVarDisplay();
				_display[_idd] = Obj;

				order = $('#editable-hotspots').sortable('serialize', {
					attribute : "sort"
				});
				ordenarElementos(order, 'Hotspots');
				recursoActualizado();
			}
			savexml = function() {
				var elemento = "", xml = "";
				_display = giveMeVarDisplay();

				for (var i = 0; i < _display.length; i++) {
					if (_display[i] != undefined) {
						var __do = _display[i].displayObject;
						__do			= '#'+$(__do).attr('id');
						rotacion = $(__do).attr("angle");
						if (isNaN(rotacion) || (rotacion == 'undefined')) {
							rotacion = 0;
						}
						if (_display[i].type == "hotspot") {
							vidX = $(__do).css("left").replace("px", "");
							vidY = Math.round($(__do).css("top").replace("px", "")) - $("#header").outerHeight() - $("hr").outerHeight();
							vidH = $(__do).height();
							vidW = $(__do).width();
							xml += "\t<elemento vidX='" + vidX + "' vidY='" + vidY + "' vidW='" + vidW + "' vidH='" + vidH + "' />\n";
						}
					}
				}
				console.log(xml);
				return xml;
			}
			$("#limit").Jhandler('editable');
			$("#editable-itemList").css({
				left : $("#carcasa").outerWidth(true),
				top : 0,
				height : $("#carcasa").outerHeight(true) + $("#editable-itemProps").outerHeight(),
				width : $(document).width() - $("#carcasa").outerWidth(true),
				'min-width' : '300px'
			});
			$("#editable-itemProps").css({
				top : $("#carcasa").outerHeight(true),
				left : 0,
				width : $("#carcasa").outerWidth(true)
			});
			$("#limit").css("margin", "0px");
			$("#url_editable,#url_arc,#urlInterfaz").remove();
			$("#right,#left").css("z-index", "1");
			$("#overall").css({
				height : $("#fondo").outerHeight(),
				width : $("#fondo").outerWidth(),
				"top" : "0px",
				"left" : "0px",
				"z-index" : 0
			});
			if (ims.interfaz.getSkin() == "musica")
				$("#overall").css("margin-top", "0px");

			$("#overall").children().each(function() {
				if (!$(this).hasClass("editable"))
					$(this).remove();
			});

			$("#overall").children().each(function() {
				$(".rotation").remove();
				var css = "width:" + (parseInt($(this).width()) + 40) + "px;" + "height:" + (parseInt($(this).height()) + 40) + "px;" + "top:" + (parseInt($(this).css("top")) - 20) + "px;" + "left:" + (parseInt($(this).css("left")) - 20) + "px;position:absolute;";

				$(this).css("z-index", 1);
				$("#overall").append("<div class='rotation' idw='" + $(this).attr("id") + "' style='" + css + "'></div>");
			});

			$(document).mouseup(function() {
				rot = false;
				if (draggingObj != "" && angulo != "") {
					draggingObj.attr("angle", angulo);
					angulo = 0;
				}
			});
			$(document).mousemove(function(e) {
				if (rot == true) {
					rotateRow(e.pageX, e.pageY);
					$(".rotate").css({
						"left" : parseInt($(".ord-n").css("left")),
						"top" : -25
					});
				}
			});
			$("#overall").css("z-index", "1");

			$(window).resize(function() {
				$("#editable-itemList").css({
					width : $(window).width() - $("#carcasa").outerWidth(true)
				});
			});
		},500);
	})
}
//});
function ucfirst(str) {
	str += '';
	var f = str.charAt(0).toUpperCase();
	return f + str.substr(1);
}
