var isiPad = navigator.userAgent.match(/iPad/i) != null;
var isAndroid = navigator.userAgent.match(/Android/i) != null;
var ultimaPantalla;
var size = 0;
var color = 0;
var face = "";
var align = "";
var href = "";
var estilo = "";
var clicker = "";
var url_files = "";
var handle, diferencia, epageX, dif = 0;
var _click = false;
var click = (('ontouchend' in window)) ? 'touchend' : 'click';

var isMuted = false;
var hasAudio = false;

$(document).ready(function() {
	// if ($("#url_interfaz").text() != "") {
	// 	url_interfaz = $("#url_interfaz").text();
	// }

	$("#url_interfaz").remove();

	document.title = 'Santillana';

	config_xml = $.parseXML(config_xml);
	url_files = $(config_xml).find("path").text();
	if($(config_xml).find("sonido").text()!=""){
		hasAudio = true;
		ims.interfaz.setSound('audio', url_files + $(config_xml).find("sonido").text());
		if (!isMobile){
			ims.interfaz.playSound("audio");
		}
	}
	
	ultimaPantalla = $(config_xml).find("pantalla").length - 1;

	cargar_actividad(0);

	if(isMobile){
		var overlay = $("<div>").attr("id","hover");
		var hover_img = $("<div>").attr("id","hover-image");
		
			var hovTop = $("#header").outerHeight(true)+($("#visor").height()-$("#visor").height()*0.30)/2;
			var hovLeft = ($("#visor").width()-$("#visor").width()*0.30)/2;
	hover_img.css({
		"top":hovTop+"px",
		"left":hovLeft+"px",
		"position":"absolute",
		"z-index":"9999"
	});
	overlay.css({

		height:$("#limit").outerHeight(true)-$("#header").outerHeight(true),
		top:$("#header").outerHeight(true)
	});
	$("#limit").append(overlay,hover_img);

	}

});

function cargar_actividad(pageNumber) {

	pageNumber = parseInt(pageNumber);
	ultimaPantalla = parseInt(ultimaPantalla);
	$("#limit").remove();	
	if ($('#audio').length == 1){
		var tiempo = $( '#audio' )[0].currentTime;
	}
	ims.interfaz.init();

	$(".ui-loader,.ui-page, #left2, #right2").remove();

	$("#content").append($("#overall").get());
	$("#overall").css("z-index", "1");
	$("#left,#right,#header").css("z-index", "5");
	$("#visor").append("<div id='visor_content'></div>");
	ims.interfaz.setTitle($(config_xml).find("titulo").text());

	$("#pregunta").append($(config_xml).find("enunciado").text());

	if($(config_xml).find("enunciado").text()==''){
		$("#pregunta").remove();
	}
	
	//$('#header p').text($('#audio')[0].readyState);
	if ($('#audio').length == 1){
		if ($('#audio')[0].readyState == 4){
			$( '#audio' )[0].currentTime = tiempo;
			if (!isiOS){
				$( '#audio' )[0].play();
			}
			
		}
	}
	if ($(config_xml).find("sonido").length > 1) {

		$("body").append("<bgsound src=\"" + $(config_xml).find("sonido") + ".wav\"  AUTOSTART=\"TRUE\"></bgsound>");
	}
	$(".tooltip").remove();
	$("#visor_content").append("<div id=\"presentacion\"></div>");
	$(config_xml).find("pantalla").each(function() {

		if (pageNumber == $(this).attr('id')) {


			ims.interfaz.addButton("Anterior", "left", "anterior", $(config_xml).find("anterior").text());
			ims.interfaz.addButton("Inicio", "left", "anterior2", $(config_xml).find("inicio").text());
			if (!isMobile) {
				ims.interfaz.addButton("silenciar", "left", "silenciar", $(config_xml).find("silenciar").text());
			}
			ims.interfaz.addButton("Siguiente", "right", "siguiente", $(config_xml).find("siguiente").text());

			ims.interfaz.addButton("Final", "right", "siguiente2", $(config_xml).find("final").text());

			if (pageNumber < ultimaPantalla) {

				ims.interfaz.enable("Final");
				ims.interfaz.bind("Final", 'cargar_actividad(' + ultimaPantalla + ')');

				ims.interfaz.enable("Siguiente");
				ims.interfaz.bind("Siguiente", 'cargar_actividad(' + (pageNumber + 1) + ')');

			}
			if (pageNumber > 0) {

				ims.interfaz.enable("Inicio");
				ims.interfaz.bind("Inicio", 'cargar_actividad(' + 0 + ')');

				ims.interfaz.enable("Anterior");
				ims.interfaz.bind("Anterior", 'cargar_actividad(' + (pageNumber - 1) + ')');

			}

			$('#center').html(' <p> ' + (pageNumber + 1 ) + ' / ' + (ultimaPantalla + 1) + ' </p> ');

			// if (ims.interfaz.sound) {
			// 	ims.interfaz.enable("silenciar");
			// 	ims.interfaz.bind("silenciar", "mute()");
			// } else {
			// 	ims.interfaz.bind("silenciar", "play()");
			// }
			
			// if($(config_xml).find("sonido").text()==""){
			// 	ims.interfaz.disable("silenciar");
			// 	ims.interfaz.bind("silenciar");
			// }
			if ( hasAudio ){
				if ( ims.interfaz.sound && !isMuted ){
					ims.interfaz.enable("silenciar");
					ims.interfaz.bind("silenciar", "mute()");
				}
				else {
					ims.interfaz.enable("silenciar");
					$('#silenciar').removeClass('silenciar');
					$('#silenciar').addClass('silenciar_on');
					ims.interfaz.bind("silenciar", "play()");
				}
			}

      orden = $(config_xml).find('orden').text();
      if(orden == ''){
          //orden = 'Orden';//Esto lo debe tomar del xml de configuracion (multi idioma)
      }
      //añadir boton icon de mostrar/ocultar la orden 
      ims.interfaz.addButton("orden1", "left", "orden", orden);
      ims.interfaz.bind("orden1","toggle_enunciado()");
      ims.interfaz.enable("orden1");
      $('#pregunta').addClass('pregunta_inf');
      $('#pregunta').css('position','absolute');

			var z = 0;

			$(this).find("item").each(function() {
				estilo = "";
				face = "";
				color = "";
				size = "";
				align = "";
				href = "";

				z++;

				var tooltip = $(this).find("tooltip").text();
				var texto = $(this).text().replace(tooltip, "");
				var foto = $(this).text().replace(link, '');
				var rotation = $(this).attr("rotation");
				var width = $(this).attr("width");
				var height = $(this).attr("height");
				var link = $(this).attr("enlace");
				var x = $(this).attr("x");
				var y = parseInt($(this).attr("y").replace('px', ''));

				if ($(this).attr("tipo") == "imagen") {
					if (url_files != "")
						foto = foto.replace("presentacion/imagenes/", "");
					$("#presentacion").append('<img id="item_' + z + '" style="position:absolute;transform:rotate(' + rotation + 'deg);-webkit-transform:rotate(' + rotation + 'deg);-moz-transform:rotate(' + rotation + 'deg);-o-transform:rotate(' + rotation + 'deg);-ms-transform:rotate(' + rotation + 'deg);left:' + x + 'px;top: ' + y + 'px;width:' + width + 'px; height:' + height + 'px;" src="' + url_files + foto.replace(tooltip, "") + '" />');

					if (link != "" || tooltip != "") {

						$("#overall").append('<div id="hot_' + z + '" class="hot" style="cursor:pointer;position:absolute;transform:rotate(' + rotation + 'deg);-webkit-transform:rotate(' + rotation + 'deg);-moz-transform:rotate(' + rotation + 'deg);-o-transform:rotate(' + rotation + 'deg);-ms-transform:rotate(' + rotation + 'deg);left:' + x + 'px;top: ' + y + 'px;width:' + width + 'px; height:' + height + 'px;"></div>');
						$("#hot_" + z).click(function() {
							if (link.indexOf("pantalla") != -1) {
								cargar_actividad(link.replace('pantalla,', ''));
							} else {
								window.open(link);
							}
						});
					}
					if (tooltip != "") {
						ims.interfaz.addPopup(z, 'hot_' + z);

						$('#content_' + z).append(tooltip);
					}
				}

				if ($(this).attr("tipo") == "texto") {
					var estilo2 = "";

					texto.replace(/<font .*?>/g, function(data) {
						estilo2 = "";
						data.replace(/[a-z]*=\".*?\"/g, function(data2) {
							var dat2Trat = data2.replace(/\"/g, "").split("=");
							//if(dat2Trat[0]==)

							switch (dat2Trat[0]) {
								case 'face':
									estilo2 += "font-family:" + dat2Trat[1] + "; ";
									break;
								case 'size':
									estilo2 += "font-size:" + dat2Trat[1] + "; ";
									break;
								case 'color':
									estilo2 += "color:" + dat2Trat[1] + "; ";
									break;
								case 'align':
									estilo2 += "text-align:" + dat2Trat[1] + "; ";
									break;
							}
						});

						var newData = data.replace("font", "span ").replace(/[a-z]*=\".*?\"/g, "").replace(" >", "style='" + estilo2 + "'>");

						texto = texto.replace(data, newData).replace("\/font", "\/span");

					});

					if (texto.indexOf("href") != -1) {
						texto.substr(texto.indexOf("href"), texto.length).replace(">", "").replace(/\"(.*?)\"/, function(data, dataClean) {
							href = dataClean;
							return href;
						});
					}

					if (href.indexOf("pantalla") != -1) {
						href = href.replace("href='", "").replace("'", "") + "";
						href = href.split(",");
						estilo += "cursor:pointer;";
						clicker = "onclick=\"cargar_actividad(" + parseInt(href[1] - 1) + ")\"";
						$("#overall").append('<div  id="item_' + z + '" style="position:absolute;transform:rotate(' + rotation + 'deg);-webkit-transform:rotate(' + rotation + 'deg);-moz-transform:rotate(' + rotation + 'deg);-o-transform:rotate(' + rotation + 'deg);-ms-transform:rotate(' + rotation + 'deg);left:' + Math.round(x) + 'px;top: ' + Math.round(y) + 'px;width:' + Math.round(width) + 'px; height:' + Math.round(height) + 'px;"><p ' + clicker + '  style="' + estilo + '">' + texto + '</p></div>');
					}

//console.log(href.indexOf("http") + '!= -1 || '+tooltip +'!= ""');
					if (href.indexOf("http") != -1 || tooltip != "") {
						$("#overall").append('<div class="item" id="item_' + z + '" style="position:absolute;transform:rotate(' + rotation + 'deg);-webkit-transform:rotate(' + rotation + 'deg);-moz-transform:rotate(' + rotation + 'deg);-o-transform:rotate(' + rotation + 'deg);-ms-transform:rotate(' + rotation + 'deg);left:' + Math.round(x) + 'px;top: ' + Math.round(y) + 'px;width:' + Math.round(width) + 'px; height:' + Math.round(height) + 'px;"><p ' + clicker + '  style="' + estilo + '">' + texto.replace("href", "target='_blank' href") + '</p></div>');
					} else {
						$("#presentacion").append('<div  id="item_' + z + '" style="position:absolute;transform:rotate(' + rotation + 'deg);-webkit-transform:rotate(' + rotation + 'deg);-moz-transform:rotate(' + rotation + 'deg);-o-transform:rotate(' + rotation + 'deg);-ms-transform:rotate(' + rotation + 'deg);left:' + Math.round(x) + 'px;top: ' + Math.round(y) + 'px;width:' + Math.round(width) + 'px; height:' + Math.round(height) + 'px;">' + texto + '</div>');
					}

					if (tooltip != "") {

						ims.interfaz.addPopup(z, 'item_' + z);
						$('#content_' + z).append(tooltip);
					}
				}

			});

		}

	});

setTimeout(function() {
	if (isiOS) {
		$('#overall').css('width',$('#carcasa').width());
	}
}, 1000);

	$(".hot").bind(click,function() {
		var id = ($(this).attr('id')).replace('hot_','');
		setTimeout(function() {
			$( '#content_'+id).jScrollPane( {
          showArrows : false,
          hideFocus : true
      });
		}, 500);
	});
	$(".item").bind(click,function() {
		var id = ($(this).attr('id')).replace('item_','');
		setTimeout(function() {
			$( '#content_'+id).jScrollPane( {
          showArrows : false,
          hideFocus : true
        });
		}, 500);
	});

	posElement();

    if(pageNumber>9){
     $('#center p').css('size','20px');
	}
	if (isMobile){
		$('#overall').css('width',$('#overall').width()-$('#bottombar').width());
	}

	if(isMobile){
		$("#hover-image").live(click,function(event){
			var audio = document.getElementById('audio');
			//audio.currentTime = tiempo;
			if(audio){
				audio.load();
				audio.play();
			}
			$('#hover-image').fadeOut();
			$('#hover').fadeOut();
		});
		
	}
			/*if(_click==false){
				event.preventDefault();
				changeSound(url_files.replace("pantallas/", "") + $(config_xml).find("sonidoGeneral").text(),false);
				_click = true;
				$("#hover-image,#hover").remove();
			}*/
	
}

function changeSound(sound,other) {
	if($( '#audio' )[0].currentTime!=0)
		$( '#audio' )[0].currentTime = 0;
	$( '#audio' )[0].src = '';
	$( '#audio' )[0].load();
	if(other == true){
		_gen[0] = false;
		$( '#audio' )[0].src = sound;
		$( '#audio' )[0].load();
		$( '#audio' )[0].addEventListener('ended',rePlay,false);
		$( '#audio' )[0].addEventListener('loadedmetadata',listPlay,false);
	}else{
		$( '#audio' )[0].pause();
		_gen[0] = true;
	}
	
}

$(window).resize(function() {
	posElement();
});

function posElement() {
	$("#fondo,#visor").height($("#content").height() - 60);
	$("#header,hr").css({
		"z-index" : "5000"
	});

	$("#presentacion").css({
		"width" : $("#fondo").width(),
		"height" : $("#carcasa").height(),
	});

	if ($('.positionbar').length == 0){
		$("#overall").css({
			"height" : $("#carcasa").height()-$('#bottombar').height()
		});
	}else{
		$("#overall").css({
			"height" : $("#carcasa").height()
		});	
	}
	
	$("#fondo").css({
		"height" : $("#overall").height()
	});

	ims.interfaz.resize();
}


$(window).load(function() {
	posElement();
});
function mute() {
	isMuted = true;
	$('.tooltip').hide();
	$('#silenciar').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar').removeClass('silenciar');
	$('#silenciar').addClass('silenciar_on');
	$('#silenciar').tooltip();
	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.bind("silenciar", "play()");
		$("audio")[0].volume = 0;
	}
}

function play() {
	isMuted = false;
	$('.tooltip').hide();
	$('#silenciar').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar').removeClass('silenciar_on');
	$('#silenciar').addClass('silenciar');
	$('#silenciar').tooltip();
	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.bind("silenciar", "mute()");
		$("audio")[0].volume = 1;
	}		
}

function toggle_enunciado(){
    $('#pregunta').fadeToggle();
}