
ims.actividad = {
   percentage: 0,
   setPercentage: null,
   resPath: null,
   sliderHandleWidth: null,
   step: 1,
   min: 0,
   max: 0,
   model: 0,
   total: 0,
   displayValue: 0,
   value: 0,
   values: 0,
   images: null,
   init: function(){
      
      if (isiOS) {
         $("body").css("margin-top", "-20px");
      }   
      $("#url_interfaz").remove();
      ims.interfaz.introduce();
      ims.interfaz.setStatement(ims.interfaz.getText("enunciado"));
   },
   setInterface: function(){
      ims.interfaz.emptyStage();

      if(config_json.textos.afterbefore_on != "1"){
         var main = "<div id='main-slider'><div id='slider'></div></div>";
         $( '#visor' ).append( main );
         this.setSliderImages();
      }else{
         var main = "<div class='main main-slider'><div class='content_slider'></div></div>";
         $( '#visor' ).append( main );
         this.setSliderImagesAfterBefore();
      }
   },
   setSliderImages: function(){
      var images     = config_json.images;
      var url_files  = ims.interfaz.urlFiles;

      var self = this;

      self.max = images.length - 1;
       $.each(images, function(i) {
         var img = '<div id="img'+images[i].id+'" class="img_slider2" style="display:none"><img src="'+url_files+images[i].url+'"></div>';
         $('#main-slider').prepend(img);
      });

      $(function() {
        $( "#slider" ).slider({
          value: self.value,
          min: self.min,
          max: self.max,
          step: self.step,
            slide: function( event, ui ) {
               var val = ui.value;
               $(".img_slider2").css("display","none");
               $("#img"+val).css("display","block");
            }
        })
        .each(function() {
          var opt = $(this).data().uiSlider.options;

          // Get the number of possible values
          var vals = opt.max - opt.min;
          vals = vals / opt.step;

          // Position the labels
          $("#slider").append('<div class="label_content"></div>');
          for (var i = 0; i <= vals; i++) {
               if(!images[i].label){
                  images[i].label = i + 1;
               }
              // Create a new element and position it with percentages
              var el = $('<label>' + images[i].label + '</label>').css('left', (i/vals*100) + '%');

              // Add the element inside #slider
              $(".label_content").append(el);

          }

        });

        $("#img"+$( "#slider" ).slider( "value")).css("display","block");

      });
   },
   setSliderImagesAfterBefore: function(){
      this.max                = config_json.images.length - 1;
      this.total              = this.max - this.min;  
      this.displayValue       = this.model; 
      this.resPath            = ims.interfaz.urlFiles;
      this.values             = this.total / this.step;
      this.images            = config_json.images;

      var template            = "<div class='slider'><div class='slider-container'><div class='slider-bar'><div class='slider-bar-highlight'></div></div><div class='slider-bar-stub'></div><div class='slider-handle bgPrimary'></div></div></div>";
      $( '.content_slider' ).append( template );

         //INIT FUNCTIONS
      this.sliderHandleWidth  =  $( '.slider-handle' ).width();
      this.loadImages();
      this.setImage();
      this.setPercentage();
      this.setMiniLabel();
      this.moveHandle();

      $( '.slider-handle' ).on('mousedown',this.engageHandle);
   },
   moveHandle: function() {
      var self = this;
      $(".slider-bar-highlight").css ('right', (100 - self.percentage * 100) + "%" );
      $(".slider-handle").css ('left', (self.percentage * 100) + "%"  );
  },
   setPercentage: function() {
      var self = this;
      self.percentage = (self.model - self.min) / self.total;
  },
   setMiniLabel: function() {
      // Position the labels
      $( '.slider-container' ).append('<div class="label_content"></div>');
      
      var self = this;
      for (var i = 0; i <= self.values; i++) {
        // Create a new element and position it with percentages
         var label = config_json.images[i].label;
         if(!label){
            label = i+1;
         }
         var el = $('<label/>');
         el.append('<span class="titulo"></span><span class="texto">' + label + '</span>');
         el.css('left', (i/self.values*100) + '%');

         // Add the element inside #slider
         $( '.label_content' ).append(el);

      }
  },
   loadImages: function() {
      var img_container = '<div class="img_slider_container"></div>';
      var self        = this;
      $(".main-slider").prepend(img_container);

      for(var i = 0; i <= self.values; i++){
        var img = '<div id="img_'+self.images[i].id+'" class="img_slider"><img src="'+self.resPath+self.images[i].url+'"></div>';
         $(".img_slider_container").append(img);
      }
  },
   setImage: function() {
      var val = this.model;
      var sel = val;
      $( 'img_slider' ).css("z-index","0");
      $( 'img_slider' ).css("width","0%");
      $( '#img_'+sel ).css("z-index","10");
      $( '#img_'+sel ).css("width","100%"); 
      if (val > 0){
         sel = parseInt(val) - 1;
         $( '#img_'+sel ).css("z-index","5");
         $( '#img_'+sel ).css("width","100%");   
      }
      if (val < this.total){
         sel = parseInt(val) + 1;
         $( '#img_'+sel ).css("z-index","15");
         $( '#img_'+sel ).css("width","0%");  
      }
  },
   engageHandle: function(event) {
      var self = ims.actividad;
      var basePercentage, basePosition, mouseMove, mouseUp;
      event.preventDefault();
      basePosition = event.screenX;
      basePercentage = self.percentage;

      mouseMove = function(event) {
         self.percentage = basePercentage + (event.screenX - basePosition) / ($( '.main-slider' ).width() - self.sliderHandleWidth);
         if (self.percentage < 0)
            self.percentage = 0;
         if (self.percentage > 1)
            self.percentage = 1;

         var modulo     = Math.round(1/self.values * 100) / 100;
         var modulo_per    = Math.round(self.percentage * 100) / 100;
         var width      = ((modulo_per/modulo) - parseInt(self.percentage/modulo)) * 100;
         var active     = parseInt(modulo_per/modulo) +1;
         $( '#img_'+active ).css("width",width+"%"); 

         if((modulo_per*100)%(modulo*100) == 0){
            var punto = (modulo_per*100)/(modulo*100);
            self.model = parseInt(self.min) + self.step*punto;
            self.setImage();
         }

         self.displayValue = Math.round((self.total * self.percentage*100) / 100) + parseInt(self.min);
         return self.moveHandle();
      };

      mouseUp = function() {
      
         $(document).off("mousemove", mouseMove);
         $(document).off("mouseup", mouseUp);
         return self.moveHandle();
      };

      $(document).on("mousemove", mouseMove);
      $(document).on("mouseup", mouseUp);
  }

};

$(document).ready(function() {
   ims.interfaz.init();
});
