
if(ims === null || ims === undefined) {
	var ims = {
		test : function() {
			console.log("ims existe");
		}
	};
}
ims.stopwatch = {

	/* propiedades */
	timer:		0,
	divClock:	'#clock',

	/* init() inicializa el interfaz. */
	init : function() {
		$(ims.stopwatch.divClock).html('<div class="display"><span class="hr">00</span><span class="min">00</span><span class="sec">00</span><span class="msec">00</span></div>');
		var h	= 			$(ims.stopwatch.divClock).find('.hr');
		var m	= 			$(ims.stopwatch.divClock).find('.min');
		var s	= 			$(ims.stopwatch.divClock).find('.sec');
		var ms	= 			$(ims.stopwatch.divClock).find('.msec');
	},
	start: function() {
		ims.stopwatch.timer = setInterval(ims.stopwatch.do_time, 10);
	},
	stop: function() {
		clearInterval(ims.stopwatch.timer);
		ims.stopwatch.timer = 0;
	},
	reset: function() {
		clearInterval(ims.stopwatch.timer);
		ims.stopwatch.timer = 0;
		h.html("00");
		m.html("00");
		s.html("00");
		ms.html("00");
	},
	do_time: function() {
		var h	= 			$(ims.stopwatch.divClock).find('.hr');
		var m	= 			$(ims.stopwatch.divClock).find('.min');
		var s	= 			$(ims.stopwatch.divClock).find('.sec');
		var ms	= 			$(ims.stopwatch.divClock).find('.msec');
		hour		= parseFloat(h.text());
		minute		= parseFloat(m.text());
		second		= parseFloat(s.text());
		msecond		= parseFloat(ms.text());

		msecond++;
		
		if(msecond > 90){
			msecond	= 0;
			second	= second +1;
		}
		if(second > 59) {
			second	= 0;
			minute	= minute + 1;
		}
		if(minute > 59) {
			minute	= 0;
			hour	= hour + 1;
		}

		h.html("0".substring(hour >= 10) + hour);
		m.html("0".substring(minute >= 10) + minute);
		s.html("0".substring(second >= 10) + second);
		ms.html("0".substring(msecond >= 10) + msecond);
	}
}