
Glo = function(){
	var config = {
		labels : {
			'indices':['A','B','C','D','E','F','G','H','I','J','K','L','M','N','Ñ','O','P','Q','R','S','T','U','V','W','X','Y','Z']
		},
		data : $.parseXML(data_xml),
		elementos : [],
		obj : [],
		ignorar : [],
		jscroll: []
	};
	function init(){
		
		this.config.ignorar = $(this.config.data).find("ignorar").text();
		var ignore = this.config.ignorar;
		ims.interfaz.init();
		ims.interfaz.setTitle($(Glo.config.data).find("titulo").text());
		//Elimino las capas inecesarias
		$("#overall,#pregunta,#fondo").remove();

		var credTxt = $(this.config.data).find('creditos[cadena="creditos"]').text();
		$("#center").addClass("button_right notdisabled sprite background copyright").attr("title",credTxt);
		if(!isMobile)
			$("#center").tooltip();
		$("#center").appendTo("#left");
		//Genero mi columna izquierda en la que estarán las palabras y las letras del glosario
		var _glosario = $("<div/>").attr("id","glosario");

		var _contenido = $("<div/>").attr("id","contenido").addClass(" swiper-container");
		//Geenro un input para relaizar la busqueda de las palabras y su contenedor
		var _inp_cont = $("<div/>").attr("id","contentImp");

		var _inp_reset = $("<div/>").attr("id","reset").text("X");

		var _busqueda = $('<input/>').attr({
						"type":"text",
						"id":"busqueda"
					});

		//Contenedor donde se guardaran las letras
		var _glo_left = $("<div/>").attr("id","gloLeft").addClass("swiper-container");
		
		var _glo_scroll = $("<div/>").addClass("swiper-scrollbar2");
		//Contenedor donde se guardaran las palabras del XML
		var _glo_right = $("<div/>").attr("id","gloRight").addClass("swiper-container");

		var letras="<div class='swiper-wrapper'><div class=' swiper-slide'>";

		var activo = " active";

		$.each(this.config.labels['indices'],function(num,letra){
			if(ignore.indexOf(letra.toUpperCase())==-1)
				letras += "<div id='indice_"+num+"' class='letter disabled"+activo+"'>"+letra+"</div>";
			activo = "";
		});

		letras += "</div></div>";

		_glo_left.append(letras,_glo_scroll);

		var palabras = "";

		var _n_count=[];
		_n_count[0]=0;

		var activo = " active";
		var _rem = [];
		$.each($(this.config.data).find("item"),function(num,obj){
			var _palabra = $(obj).find("palabra").text();
			var _palabraTitulo =$(obj).find("palabratitulo").text();
			var _elemento = $(obj).find("elementos > elemento").text();
			var _n = checkLetter(_palabra);
			if(ignore.indexOf(_n[1].toUpperCase())==-1){
				if(_n[0]!=_n_count[1])
					_n_count[0]=0;
				if(_n_count[0]==0){
					palabras += "<div id='index_"+_n[0]+"' class='index"+activo+"'>"+_n[1]+"</div>";
					_n_count[0]++;
					_n_count[1]=_n[0];
					_rem.push("#indice_"+_n[0]);
				}
				palabras += "<div id='palabra_"+_n[0]+"' idw='word_"+num+"' class='palabra"+activo+" total_"+_n[0]+"' word='"+_palabra+"'>"+_palabraTitulo+"</div>";
				activo = "";
				Glo.config.elementos[num] = _elemento;
			}
		});

		palabras += "";
		_glo_right.append(palabras);

		_busqueda.on({
			keydown : function(e){
				if((e.which ==13))
					findWord($(this).val());
			},
			click : function(){
				editable = '';
				$(this).val("");
			},
			focusout: function(){
				editable = undefined;
			}
		});

		_inp_reset.on({
			click:function(){
				_busqueda.val("");
				findWord("");
			}
		});

		_inp_cont.on({
			click:function(){
				$("#busqueda").focus();
			}
		});

		_inp_cont.append(_busqueda,_inp_reset);
		_glosario.append(_inp_cont,_glo_left,_glo_right);

		$("#visor").append(_glosario,_contenido);
		
		var swiper = new Swiper('#gloLeft', {
		    mousewheelControl : true,
		    mode:'vertical',
		    slidesPerView:'auto',
		    calculateHeight:true,
		});
		
		if(isMobile){
			$("#gloRight .swiper-slide").width("100%");
			$("#gloRight").css("overflow-y","auto");
		}

		this.config.obj[0] = swiper;

		$(".letter").live("click",function(event){
			var _this_index = $(this).attr("id").replace("indice_","");
			if( $("#index_"+_this_index).length>0){
				var _this_top = $("#index_"+_this_index).position().top;
				$(".letter.active").removeClass("active");
				$(this).addClass("active");
				Glo.config.jscroll.scrollTo(parseInt(0), parseInt(_this_top));
				
				
				Glo.config.obj[0].reInit();

			}
		});
		$(".palabra").live("mouseup",function(event){
			event.preventDefault();
			var _this_index = $(this).attr("idw").replace("word_","");
			var _this_top = $(".palabra[idw='word_"+_this_index+"']").position().top;

			$(".palabra.active").removeClass("active");

			$(this).addClass("active");
			Glo.config.jscroll.scrollTo(parseInt(0), parseInt(_this_top));
			$("#contenido").data('jsp').scrollTo(parseInt(0), parseInt(0));
			setActiveContent();


		});
		setActiveContent();

		// $("#contenido img").live("click",function(event){
		// 	event.preventDefault();
		// 	$("#pop_img,#overlay").remove();

		// 	var overlay = $("<div/>").attr("id","overlay");
		// 	$("#content").append(overlay);
		// 	$("#pop_img").css("display",'none');
		// 	ims.interfaz.addPopup("img",$(this).attr("id"));
		// 	$("#pop_img").removeClass("pop_up").addClass("pop_over");
		// 	$("#content_img").removeClass("pop_up_content").addClass("pop_over_content");
			

		// 	$("#content_img").html($(this).clone());
		// 	var image = $("#content_img").children();
		// 	image.load(function(){
		// 		var image = $(this);
		// 		image.removeAttr("style");

		// 		var _imageWidth = image.width();
		// 		var _imageHeight = image.height();

		// 		var _top = false;
		// 		var _left = false;

		// 		var _ratio = _imageWidth/_imageHeight;

		// 		if ( _imageHeight > 550 ){
		// 			_imageHeight = 550;
		// 			_imageWidth = 550*_ratio;
		// 		}
		// 		if ( _imageWidth > 800 ) {
		// 			_imageWidth = 800;
		// 			_imageHeight = 800/_ratio;
		// 		}

		// 		if( _imageHeight > 300 ){
		// 			_top = 570 - _imageHeight;
		// 		}
				

		// 		$(this).attr( "width", _imageWidth );
		// 		$(this).attr( "height",  _imageHeight );

		// 		if( _imageWidth >$("#content_img").width()){
		// 			$("#content_img").width( _imageWidth );
					
					
		// 		}else{
		// 			if( _imageHeight >$("#content_img").height()){
		// 				$("#content_img").height( _imageHeight );
		// 			}
		// 		}
		// 		var mT = ($("#limit").height()-$("#content_img").height())/2;
		// 		var mL = ($("#limit").width()-$("#content_img").width())/2;

		// 		if ( _top != false ){
		// 			$("#pop_img").css({
		// 				"top": _top+"px",
		// 			});
		// 		}
				
		// 		if($("body").hasClass("positionbar")){
		// 			$("#overlay").css({
		// 				'width':'1091px',
		// 				'height':'517px'
		// 			});
		// 		}
		// 	});
		// 		$("#pop_img,#overlay").css("display","block");

		// 	ims.interfaz.resize();
			
			
		// });
		var _texto = $(Glo.config.data).find('creditostxt').text();
		
		if(_texto.length == 0){
			$('.copyright').remove();
		}

		$("#center").live("mousedown",function(event){
			event.preventDefault();
			if(typeof($("#content_img").data('jsp'))!='undefined'){
				$("#content_img").data('jsp').destroy();
			}
			$("#pop_img,#overlay").remove();

			var overlay = $("<div/>").attr("id","overlay");
			$("#content").append(overlay);
			$("#pop_img").css("display",'none');
			ims.interfaz.addPopup("img",$(this).attr("id"));
			$("#pop_img, #overlay").css("display","block");

			var _title = $(Glo.config.data).find('creditos[cadena="creditos"]').text();
			var _texto = $(Glo.config.data).find('creditostxt').text();
			var _wrap = "<div class='swiper-slide' id='_creditostxt'><p></br>"+_texto+"</p></div>"; 
			var _glo_scroll4 = $("<div/>").addClass("swiper-scrollbar4");

			$("#pop_img").prepend( '<div id="wrapTitleCredits">'+_title+'</div>' );
			$("#wrapTitleCredits").css({
				  "float": "left",
				  "left": "16px",
				  "position": "relative"
			});
			$("#content_img").append(_wrap);

			$("#content_img").jScrollPane({
				verticalDragMinHeight: 20,
				verticalDragMaxHeight: 20,
				mouseWheelSpeed: 500
			});
			if(isMobile)
				hideScrollBar();
			
			ims.interfaz.resize();
			
			
		});

		$(".goWord").live('click',function(event){
			event.preventDefault();
			var _word = $(this).attr('wordf');
			$('.palabra').each(function(){
				if($(this).text()==_word){
					var _this_index = $(this).attr("idw").replace("word_","");
					var _this_top = $(".palabra[idw='word_"+_this_index+"']").position().top;

					$(".palabra.active").removeClass("active");

					$(this).addClass("active");
					Glo.config.jscroll.scrollTo(parseInt(0), parseInt(_this_top));
					
					setActiveContent();
				}
			});
		});

		$('#close_img').live("click",function(){
			$("#overlay,#pop_img").remove();
		});
		
		ims.interfaz.resize();

		$("#gloRight").jScrollPane({
			verticalDragMinHeight: 20,
			verticalDragMaxHeight: 20,
			mouseWheelSpeed: 500
		});
		this.config.jscroll = $("#gloRight").data('jsp');
		$(".jspDrag").addClass("swiper-scrollbar-drag");
		$(".jspTrack").addClass("swiper-scrollbar2");

		if(isMobile){
			hideScrollBar();
			$(".jspPane").width($(".jspPane").parent().width());
		}

		$.each(_rem,function(index,obj){
			$(obj).removeClass("disabled");
		});

        introduce_retorno();

		
	};

	function findWord(value){
		$(".hide").removeClass("hide");
		$(".palabra").each(function(){
			var _this = $(this);
			var _attr = _this.attr("word");
			var _text = _this.text();
			var _indexOf = false;
			var _result = false;
			
			if((_text == value)||(_text.toLowerCase() == value.toLowerCase())||(_text.toUpperCase() == value.toUpperCase())||(_attr == value)||(_attr.toLowerCase() == value.toLowerCase())||(_attr.toUpperCase() == value.toUpperCase()))
				_result = true;
			
			if((_text.toUpperCase().indexOf(value.toUpperCase()) != -1)||(_attr.toUpperCase().indexOf(value.toUpperCase()) != -1)||(_text.toLowerCase().indexOf(value.toLowerCase()) != -1)||(_attr.toLowerCase().indexOf(value.toLowerCase()) != -1)||(_text.indexOf(value) != -1)||(_attr.indexOf(value) != -1))
				_indexOf = true;
			
			if(_result == true || _indexOf == true){
				var _this_top = _this.position().top;
				$(".palabra.active").removeClass("active");
				$(this).addClass("active");
				if(_indexOf==false){
					Glo.config.jscroll.scrollTo(parseInt(0), parseInt(_this_top));
					setActiveContent();
				}
				else{
					Glo.config.jscroll.scrollTo(parseInt(0), parseInt(0));
					// $(".swiper-wrapper").css({
					// 	'-webkit-transform': 'translate3d(0px, 0px, 0px)',
					// 	'-moz-transform': 'translate3d(0px, 0px, 0px)',
					// 	'-ms-transform': 'translate3d(0px, 0px, 0px)',
					// 	'transform': 'translate3d(0px, 0px, 0px)'
					// });

				}
				
				return;

			}else{
				_this.addClass("hide");
			}
		});
		
		$(".index").each(function(){
			var nWord = 0;
			var _this = $(this);
			var _pos = _this.attr("id").replace("index_","");
			if($(".total_"+_pos).not(".hide").length==0){
				$("#indice_"+_pos).addClass("hide");
				$(this).addClass("hide");
			}
		});
		if(value != ""){
			$(".disabled").addClass("hide");
		}

		Glo.config.obj[0].reInit();
			Glo.config.jscroll.reinitialise();
				$(".jspCap").remove();
				$(".jspDrag").addClass("swiper-scrollbar-drag");
				$(".jspTrack").addClass("swiper-scrollbar2");

				if(isMobile){
					hideScrollBar();
					$(".jspPane").width($(".jspPane").parent().width());
				}

	};

	function checkLetter(word){
		var letra = word[0];
		var letras = Glo.config.labels['indices'];
		var _return = [];
		_return[0] = letras.indexOf(letra);
		_return[1] = letras[_return[0]];
		return _return;
	};
	function setActiveContent(){
		if(typeof($("#contenido").data('jsp'))!='undefined'){
			$("#contenido").data('jsp').destroy();
		}
		var _this = $(".palabra.active");

		var _num = _this.attr("idw").replace("word_","");
		var _title = "<div id='title'>"+_this.html()+"</div>";
		var contentGlo = Glo.config.elementos[_num].replace(/href="event:/g,'class="goWord" style="cursor:pointer;" wordF="');

			
		$("#contenido").html("<div class='swiper-slide'>"+_title+contentGlo+"</div>");
		$("<div class='linea'></div>").insertAfter("#title");
		$("#contenido").find("img").hide();
		if($("#contenido").find("img").length>0)
			$("#contenido").find("img").load(function(){
				var _this = $(this);
				if(_this.width()>=$("#contenido").width())
					_this.width($("#contenido").width()-15);
				$(this).show();

			});
		$("#contenido").jScrollPane({
				verticalDragMinHeight: 20,
				verticalDragMaxHeight: 20,
				autoReinitialise:true
			});

		if(isMobile)
			hideScrollBar();
	};
	function hideScrollBar(){
		$(".swiper-scrollbar3,.swiper-scrollbar4,.swiper-scrollbar,.swiper-scrollbar2").addClass("hide");
	}
	return {config:config,init:init}
}();

$(function() {
	Glo.init();	
});
