var isAndroid = navigator.userAgent.match(/Android/i) != null;
var isiOS = navigator.userAgent.match(/(iPad)|(iPhone)|(iPod)/i) != null;
var isMobile = (isiOS || isAndroid);
var isIE = $.browser.msie;
var isMoz = $.browser.mozilla !== undefined;
var isOp = $.browser.opera;
var version = parseInt($.browser.version);
var tooltext = "";

var click = (('ontouchend' in window)) ? 'touchend' : 'click';

$(".tool").live("mouseover", function(e) {
	tooltext = $(this).data().title;
						
	if (!($(this).hasClass("notdisabled"))) {
		$(".tooltip").hide();
	}
});

if(typeof ims == "undefined"){
	var ims = {
		test : function() {
			console.log("ims existe");
		}
	};
};

$(window).resize(function(){
	if(typeof(editable)=="undefined") {
		ims.interfaz.resize();
	}
});				

/*
if ( typeof document != 'undefined' && document.readyState != 'complete' && window.addEventListener ) {
   window.addEventListener( 'DOMContentLoaded', function( e ) {
      ims.interfaz.init();
      window.addEventListener( "scroll", ims.interfaz.posicionar, false );
      window.addEventListener( "resize", ims.interfaz.posicionar, false );
      window.addEventListener( "load",  ims.interfaz.posicionar, false );

   });
}else{
   $( window ).ready( function(){
      ims.interfaz.init();
   }
   );
   $( window ).resize( function(){
      ims.interfaz.posicionar();
   }
   );
   $( window ).load( function(){
      ims.interfaz.posicionar();
   }
   );
   $( window ).scroll( function(){
      ims.interfaz.posicionar();
   }
   );
};
*/
ims.interfaz = {
	// propiedades de sonido
	sound : true,
	//----------------
	widthLimit : '975',
	heightLimit : '510',
	iecompatible : true,
	ie8compatible : true,
	Mp3Mp4compatible:true,
	configurationLoaded: false,
	zoomRatio: 1,
	audios : [],
	texts: [],
	urlFiles: "",
	texto1: "",
	browserTitle: "Santillana",
	showHeader: true,
	init : function(posicionador) {
		this.disableIE();
   		document.title = this.browserTitle;
		
   		$("#url_interfaz").remove();
   		
		if ((!isMobile && isIE) || (!this.Mp3Mp4compatible)){
		    if ((!this.Mp3Mp4compatible) || (!this.iecompatible) || (version <= 7) || ((version==8) && !this.ie8compatible)) {
			    $("body").append('<div class="changeBrowser">Este recurso no es compatible con esta versión de navegador. Le recomendamos usar la ultima versión de Chrome o Safari.<br />Copie el siguiente enlace en su navegador para ver el recurso:<br /><br />' + $(location).attr('href') + '</div>');
			    $(".ui-page").remove();
			    $("*").css({
				    '-webkit-user-select': 'auto',
				    '-khtml-user-select': 'auto',
				    '-moz-user-select': 'auto',
				    '-o-user-select': 'auto',
				    'user-select': 'auto'
			    });
			    $("body").css({
				    'background-color': '#78c3ed'
			    });
			    $(".changeBrowser").css({
				    'background-color': '#ffffff',
				    'width': '800px',
				    'margin': '50px auto 0px auto',
				    'padding': '20px',
				    'overflow': 'auto'
				    
			    });
			    throw "stop execution";
		    }
    	}
		
		var _html = '<div id="limit"><div id="carcasa"><div id="content">';
		if(this.showHeader){
			_html += '<div id="header"><div id="titular" class="bgasignatura_100"><div id="nb"></div></div><div class="sprite background logo"></div><div class="sprite background cerrar"></div></div>';
		}
		_html += '<div id="visor"><div id="pregunta"></div><div style="clear:both;"></div></div><div id="bottombar"><div id="left"></div><div id="center"></div><div id="right"></div></div></div>';
		_html += '</div></div>';
		$("body").append(_html);
		
		if (isMobile) {
		
			$("body").addClass('tabletconv');
			
			if (!isiOS) {
				this.setPositionBar();
				this.widthLimit = '1091';
				this.heightLimit = '600';

			}
			
		}else{
			// $("#header .cerrar").hide();
		}
		
		if (typeof(vars['ud'])!="undefined") {
			$('#nb').text(vars['ud']);
		} else {
			$('#titular').remove();
			$('#header').css('padding-left','30px');
		}

		$("body").addClass('asignatura_'+vars['as']);

		this.resize();
		this.showTooltips();
		
	    this.setSound('good', url_interfaz + 'audio/good.mp3');
	    this.setSound('bad', url_interfaz + 'audio/bad.mp3');
	    this.setSound('result', url_interfaz + 'audio/result.mp3');
		
		$("body").css('background-color', '#cccccc');
		$("body").css('overflow', 'auto');
		$("#limit").css('background-color', '#ffffff');
		
		if(typeof(editable)=="undefined") {
			$("#limit").css('margin', 'auto');
			$("#limit").css("top", Math.round(($(window).height() - this.heightLimit) / 2));
			$("#limit").css("position","relative");
		}
		
		$("#limit").css("width", this.widthLimit + "px");
		$("#carcasa").css("width", this.widthLimit + "px");
		$("#content").css("width", this.widthLimit + "px");
		
		$("#limit").css("height", this.heightLimit + "px");
		$("#carcasa").css("height", this.heightLimit + "px");
		$("#content").css("height", this.heightLimit + "px");
		
		$('.pop_up').css("margin-left", ($("#limit").width() - $('.pop_up').width()) / 2);
		$("#fondo").width($("#content").width());
		$("#fondo").height($("#content").height());
		$("#overall").width($("#content").width());
		$("#overall").height($("#content").height());
		
		if(typeof(editable)=="undefined") {
			try{

			}catch(err){
				
			}
		}
		
		if(!this.configurationLoaded){
			this.loadConfiguration();	
		}
	    //Añadimos el botón de retorno al recurso
	    if(!posicionador){
		    this.enableHistoryButton();
		    ims.actividad.init();
	    }else{
	    	ims.posicionador.init();
	    }
	},
	loadConfiguration: function(){
		//Para los que tienen xml y no json

		if ( typeof (config_json) == "undefined") {
			//Para la galeria
			if ( typeof (config_xml) == "undefined") {
				//Para el glosario
				if ( typeof (cat_xml) == "undefined") {
					if ( typeof (master_xml) == "undefined") {
						config_xml = data_xml;
					}else{
						config_xml = master_xml;
					}
				}else{
					config_xml = cat_xml;
				}
			}
			
			config_xml = $.parseXML(config_xml);
			
			this.setUrlFiles($(config_xml).find("path").text());
	    	this.setTitle($(config_xml).find("introduccion").find("titulo").text());
	    	this.setTexto1($(config_xml).find("introduccion").find("texto1").text());

			//textos
			$(config_xml).find('palabras').children().each(function(key, item){
				var _tag = item.tagName;
				switch(_tag){
					case "reproducir":
						_tag = "play";
						break;
					case "pausar":
						_tag = "pause";
						break;
				}
				ims.interfaz.setText(_tag, item.textContent);
			});
			//TODO
			$(config_xml).find('langs').children().each(function(key, item){
				ims.interfaz.setText(item.tagName, item.textContent);
			});
			$(config_xml).find('textos').children().each(function(key, item){
				ims.interfaz.setText(item.tagName, item.textContent);
			});
		}
		else{
			this.setUrlFiles(config_json.path);
			config_json.textos.titulo = config_json.textos.titulo.replace(/<p>/g,'').replace(/<\/p>/g,'');
	    	this.setTitle(config_json.textos.titulo);
	    	
	    	if(datosConfiguracion.tipo == "actividad"){
	    		this.setTexto1(config_json.introduccion.texto1);
	    	}
			//textos
			$.each(config_json.textos, function(i,item){
				ims.interfaz.setText(i, item);
			})
		}
		
	    if(datosConfiguracion.interfaz == 'infantil'){

	    }else if(datosConfiguracion.interfaz == 'primaria'){
			$('body').addClass('infantil');
		}else if(datosConfiguracion.interfaz == 'secundaria'){
			$('body').addClass('secundaria');
		}
		
		this.configurationLoaded = true;
	},
	introduce : function(){
		var self = this;

	    if (this.getTexto1().length != 0) {
            
			var IntTit = this.getText('introduccion');
			var IntTex = this.getTexto1() ;

			ims.interfaz.setTitle( $(config_xml).find("introduccion").find("titulo").text() );
			
			$("#visor").append('<div id="intro_title">'+ IntTit +'</div><div id="intro_text">'+ IntTex +'</div>');
			$('#overall').hide();

			ims.interfaz.addButton( "Siguiente", "right", "siguiente", self.getText("comenzar") );
			ims.interfaz.enable( "Siguiente" );
			ims.interfaz.bind( "Siguiente", 'ims.pagination.nextPage()');
			ims.interfaz.resize();

	    } else {
	    	ims.interfaz.emptyStage();
	        ims.actividad.setInterface();
	    }
	},
	resize : function() {
		var ancho_doc = $(document).width();
		var alto_doc  = $(document).height();
		var ancho_win = $(window).width();
		var alto_win  = $(window).height();

		if(typeof(editable)=="undefined") {
		
	    	if (isMobile) {
				if ((ancho_doc / this.widthLimit) <= (alto_win / this.heightLimit)) {
					ims.interfaz.zoomRatio = (ancho_win-2) / this.widthLimit;
				} else {
					ims.interfaz.zoomRatio = (alto_win-2) / this.heightLimit;
				}
			} else {
				// Controlo si la actividad no cabe en el navegador. Si no cabe habilito el zoom aún siendo un sobremesa.

				if ( (ancho_doc < this.widthLimit) || (alto_doc < this.heightLimit)) {

					if ((ancho_doc / this.widthLimit) <= ((alto_doc-4) / this.heightLimit)) {
						ims.interfaz.zoomRatio = ancho_win / this.widthLimit;
					} else {
						ims.interfaz.zoomRatio = alto_win / this.heightLimit;
					}

				}
			}

			if (ims.interfaz.zoomRatio != 1) {
				$("#limit").css({
					"zoom": ims.interfaz.zoomRatio ,
					"-moz-transform": "scale("+ims.interfaz.zoomRatio+")"
				});
			}
			$("#limit").css("top", Math.round(((alto_win-2) - (this.heightLimit * ims.interfaz.zoomRatio)) / 2));
			$("#limit").css("margin", "0 auto");
						
		}
		//$('.pop_up').css("left", ($('#content').width() - ($('#content').width()/2)) / 2+"px").css("top", ($('#content').height() - ($('#content').height()/2)) / 2);
		if(typeof ims.actividad.resize === "function"){
			ims.actividad.resize();
		}
	},
	positioning : function(){
	    if (!this.getPositionBar()){     
	        $(window).resize(function () {
	            $("#visor").height($("#content").height() - $("#bottombar").height());
	        });
	    }else{
	        $("#visor").height($("#bottombar").height());
	        $(window).resize(function () {
	            $("#visor").height($("#bottombar").height());
	        });
	        $('#left').css('margin','0px 0px 0px 14px');
	    }
	},
	getSkin : function() {
		return this.skin
	},
	getSubSkin : function() {
		return this.subSkin
	},
	getPositionBar: function(){
		return $("body").hasClass('positionbar');
	},
	getText: function(index){
		return this.texts[index];
	},
	getTexto1: function(index){
		return this.texto1;
	},
	getUrlFiles: function(){
		return this.urlFiles;
	},
	setPositionBar: function(){
		$("body").addClass('positionbar');
	},
	setText: function(index, content){
		this.texts[index] = content;
	},
	setTexto1: function(value){
		this.texto1 = value;
	},
	setUrlFiles: function(value){
		this.urlFiles = value;
	},
	addButton : function(id, layer, className, title) {
		if (title == '' || !(title)) {
			console.log("La variable tooltip no puede estar vacia")
		} else {
			if (layer == '' || !(layer)) {
				console.log("Especifique la capa")
			} else {
				if ((layer != "left") && (layer != "right") && (layer != "left2") && (layer != "right2")) {
					console.log("Capa no válida. Use \"left\" o \"right\"")
				} else {
					var e = "<div id=\"" + id + "\" class=\"button_" + layer + " " + "sprite" + " " + "background" + " " + className + " " + "tool\" title=\"" + title + "\"></div>";
					$("#" + layer).append(e);
					if (!isMobile) {
						$("#" + id).tooltip();
					}
				}
			}
		}
	},
	enable : function(a) {
		$("#" + a).addClass("notdisabled")
	},
	disable : function(a) {
		$("#" + a).removeClass("notdisabled")
	},
	disableIE: function() {
		this.iecompatible = false;	
	},
	disableIE8: function() {
		this.ie8compatible = false;	
	},
	disableMp3Mp4: function() {
		this.Mp3Mp4compatible = false;	
	},
	bind : function(a, b) {
		$("#" + a).unbind('click');
		if (!(b) || b == '') {
			console.log("El parámetro funcion está vacio o no existe")
		} else {
			$("#" + a).bind("click", function(e) {
				eval(b)
			})
		}
	},
	unbind : function(a) {
		$("#" + a).unbind('click');
	},
	setSound : function(a, b) {
		if (isIE && version <=8) {
			this.audios[a] = b;
			return
		} else {
			$("body").append('<audio class="imsAudio" id="' + a + '" name="' + a + '" src="' + b + '" preload="auto"></audio>');
		}
	},
	playSound : function(a) {
		$(".imsAudio").each(function(){
			if($(this)[0].currentTime !=0){
				$(this)[0].pause();
				$(this)[0].currentTime = 0;
			}
		});
		if (this.sound) {
			if (isIE && version <=8) {
					$("body").append('<bgsound src="' + this.audios[a] + '"  AUTOSTART="TRUE"></bgsound>');
					return
			};

			$("#"+a)[0].play()
		}
	},
	pauseSound : function(a) {
		$("#"+a)[0].pause()
	},
	enableSound : function() {
		this.sound = true;
	},
	disableSound : function() {
		this.sound = false;
	},
	setTitle : function(a) {
		if (!(a) || a == '') {
			console.log("El parámetro title está vacio o no existe")
		} else {
			$("#header").prepend(a)
		}
	},
	setStatement: function(value){
		if($("#pregunta").length == 0){
			$("#visor").append('<div id="pregunta" />');
		}
        $('#pregunta').addClass('pregunta_inf');
		$("#pregunta").append(value.replace("<br>", ""));
		
		if(datosConfiguracion.interfaz == 'infantil'){
			$('#pregunta').css('position', 'absolute');
		}
	},
	setTooltip: function(_element, _tooltip){
		$('.tooltip').hide();
		$('#'+_element).attr('title', _tooltip);
		$('#'+_element).tooltip();
	},
	showTooltips : function() {
	
		$("#left, #right").bind('mousemove', function(e){
			var _container = this;
			$(".tooltip").mouseenter(function(){
				$(this).hide();
			});
			$('.tooltip').css({
				left : e.pageX,// - (_container.id == "right" ? $(this).width() : 0),
				top : e.pageY - 45
			})
		});
		
/*		$("#right").bind('mousemove', function(e) {
			var flag = false;
			$(".tooltip").each(function(index) {
			
				if ( $(this).text() == tooltext ) {
					if(!flag) {
					
//						$('.tooltip').css({
//							left : e.pageX - 400,
//							top : e.pageY - 80
//						});
						
						$('.tooltip').css({
							left : e.pageX - $(this).width(),
							top : e.pageY - 45
						});
						
						flag = true;
					}
				}
				
			}); 

			$(".tooltip").mouseenter(function() {
				$(this).css({
					left : parseInt($(this).css("left")) - 400,
					top : parseInt($(this).css("top")) - 80
				});
			});
		});*/
	},
	addPopup : function(a, b) {
		var c = '<div id="pop_' + a + '" class="pop_up" style="left:'+($('#content').width() - ($('#content').width()/2)) / 2+'px;top:'+($('#content').height() - ($('#content').height()/2)) / 2+'px;"><div id=close_' + a + ' class="pop_up_close sprite background"></div><div id="content_' + a + '" class="pop_up_content"></div></div>';
		$("#content").append(c);
		ims.interfaz.enable(b);
		ims.interfaz.bind(b, "$('#pop_" + a + "').fadeIn('slow');");
		ims.interfaz.bind('close_' + a + '', '$(\'#pop_' + a + '\').fadeOut(\'slow\');');
		$("#pop_" + a).css({"padding":"15px 0px 35px 20px"});
	},
	showResults : function(aciertos, total) {
		var _sound = "good";
		if ( aciertos != total ) {
			_sound = "bad";
		}
		setTimeout( function(){
			ims.interfaz.playSound(_sound);
		}, 200 );

		var _style = '';
		if(total.length > 2){
			_style = ' style="font-size: 20px;"';			
		}

		$("#center").append("<p"+_style+">" + aciertos + "<span class='marc'> / " + total + "</span></p>");
		$("#center").show("");
		
		this.disable( "comprobar" );
		this.enable( "versolucion" );
		this.bind( "versolucion", 'ims.interfaz.solucion()' );
		
		//TODO
		//disable comprobar button
		
//		this.bind( "reiniciar", "ims.interfaz.setPagination('previous')" );
//		this.enable( "reiniciar" );
	},
	setWidthLimit : function(a) {
		this.widthLimit = a;
	},
	setHeightLimit : function(a) {
		this.heightLimit = a;
	},
	//TODO. Deprecated??
	centradoVertical : function(capa, clase){
		//Centramos tanto las preguntas como las definiciones en función de las que haya. No hace falta position absolute
		var total_tam_p = 0;
		var p 			= 0;
		//Recorremos cada objeto por si hay alguna que no tenga el mismo tamaño y para calcular su nº
		$('.'+clase).each(function(i) {
			total_tam_p = total_tam_p + $(this).height() + parseInt($(this).css('padding-top')) + parseInt($(this).css('padding-bottom')) + parseInt($(this).css('border-width'))*2;
			p = i+1;
		});
		var margin_p 	= ($('#'+capa).height() - total_tam_p)/(p + 1);
		$('.'+clase).css('margin-top',margin_p);
	},
	showStars : function(obj) {
		var stars = new Array();
		for(var n = 0; n <= 5; n++){
			var id = "st_"+obj.attr("id")+"_"+n;
			
			var myX = parseInt(obj.offset().left - $("#visor").offset().left),
				myY = parseInt(obj.offset().top - $("#visor").offset().top);
			var star = $("<div/>").addClass("stars").attr("id",id).css({top: myY, left: myX});
//			stars.push(id);
			$("#visor").append(star);
//		}
//		var index = 0;
			
			//second = false
//		$.each(stars,function(i,id){
//			var _this = $("#"+id);
			var _this = star;

//			index++;
			var index = n + 1;
			
			if(index <= 3/*&&second==false*/){
				_this.css("left", parseInt(_this.css("left")) + obj.width());
			}else if(index > 3){
				index=0;
//				second=true;
			}
			
			var increment = index * 10;//+"0";			
			var mTop = myY -parseInt(increment);
			var mLeft = myX - parseInt(increment);
			
			_this.animate({top: mTop, left: mLeft, opacity: "0.25"}, 1000, function(){
				$(".stars").remove();
			});
		}
//		)
	},
	emptyStage: function() {
	    $("#center").empty();
	    $("#respuesta").empty();
	    $('.tooltip').hide();
	    $("#pregunta").empty();

//	    $( "#overall" ).remove();
//	    $( "#right2" ).remove();
	    
	    if(typeof ims.actividad.emptyStage === "function"){
	    	ims.actividad.emptyStage();	
	    }
	    ims.interfaz.resize();
	},
	order: function(){
		if(ims.interfaz.getText('orden') == ""){
			ims.interfaz.setText("orden","Orden");
		}
		if(datosConfiguracion.interfaz == 'infantil'){
	        //añadir boton icon de mostrar/ocultar la orden 
	        ims.interfaz.addButton("orden1", "left", "orden", ims.interfaz.getText('orden'));
	        ims.interfaz.bind("orden1", "ims.interfaz.toggle_enunciado()");
	        ims.interfaz.enable("orden1");
	    }
	},
	enableHistoryButton: function(){
		introduce_retorno();
	},
	solucion: function() {
console.log('aa solucion');
	    setTimeout(function () {
	        ims.interfaz.playSound('good');
	    }, 200);
	    this.disable("comprobar");
	    this.disable("versolucion");
	    
	    this.unbind("comprobar");
	    this.unbind("versolucion");
	    
	    if(typeof ims.actividad.solucion === "function"){
	    	ims.actividad.solucion();
	    }
	},
	toggle_enunciado: function() {
	    $('#pregunta').fadeToggle();
	},
	setBackgroundImage: function(src, x, y, width, height, rotation, container){
console.log('background image', arguments);
		if(!container) container = "fondo";
		width = (width) ? Math.round(width) + "px" : "auto";
		height = (height) ? Math.round(height) + "px" : "auto";
		x = (x) ? Math.round(x) + "px" : "right";
		y = (y) ? Math.round(y) + "px" : "center";
		if(!rotation) rotation = 0;

		if(src != ""){
			$("#"+container).css({
				"background-image": "url("+ims.interfaz.getUrlFiles() + src +")",
				"background-repeat": "no-repeat",
				"background-position":  x + " " + y,
				"background-size": width + " " + height,
				"rotation": rotation,
				'-webkit-transform': 'rotate('+rotation+'deg)',
				'-moz-transform': 'rotate('+rotation+'deg)'				
			});
		}
	}
};

ims.pagination = {
	direction: "next",
	screen: 0,
	totalScreens: 0,
		//Navigation
	init: function(){
		   ims.interfaz.addButton( "previous", "left", "anterior", ims.interfaz.getText("anterior") );//class anterior2 for karaoke
		   ims.interfaz.addButton( "next", "left", "siguiente", ims.interfaz.getText("siguiente") );//class siguiente2 for karaoke

		   ims.interfaz.bind("next", "ims.pagination.nextPage()");
		   ims.interfaz.bind("previous", "ims.pagination.prevPage()");
		   
		   ims.interfaz.enable("next");
	},
	getScreen: function(){
		return this.screen;
	},
	getScreens: function(){
		return this.totalScreens;
	},
	getTotalScreens: function(){
		return this.totalScreens;
	},
	getDirection: function(){
		return this.direction;
	},
	setScreen: function(value){
		this.screen = parseInt(value);
	},
	setTotalScreens: function(value){
		this.totalScreens = parseInt(value) - 1;//restamos uno porque la pantalla actual inicia en cero.
	},
	setDirection: function(value){
		this.direction = value;
	},
	prevPage: function() {
console.log( "prevPage" );
	    ims.interfaz.emptyStage();
	    this.setDirection("previous");
	    
	    if(typeof ims.actividad.prevPage === "function"){
	    	ims.actividad.prevPage();
	    }
	    
	    this.paginate();
	},
	nextPage: function() {
console.log( "nextPage" );
		ims.interfaz.emptyStage();
	    this.setDirection("next");
	    
	    if(typeof ims.actividad.nextPage === "function"){
	    	ims.actividad.nextPage();
	    }
	    
	    this.paginate();
	},
	paginate: function(){
		// Set Interfaz
		switch(this.getDirection()){
			case 'next':
				this.setScreen(this.getScreen() + 1);
				break;
			case 'previous':
				this.setScreen(this.getScreen() - 1);
				break;
		}

		if(this.getScreen() == 0){
			ims.interfaz.disable("previous");
			ims.interfaz.enable("next");
		}
		else if(this.getScreen() > 0){
			ims.interfaz.enable("previous");
			
			if (this.getTotalScreens() > 1){
			      ims.interfaz.enable("next");
			   }
		}
		if(this.getScreen() == this.getTotalScreens()){
			ims.interfaz.disable("next");
			ims.interfaz.enable("previous");
		}
		ims.actividad.setInterface();
	},
	//end navigation
};
