var isiPad = navigator.userAgent.match(/iPad/i) != null;
var isAndroid = navigator.userAgent.match(/Android/i) != null;
var tipoActividad = "Desplegable";
var url_interfaz = "";
var url_files = "";
$(window).resize(function(){
	scroll();
});

function scroll() {

	if ($("#intro_text").html() == null) {

			$("#carcasa").children().not(".pop_up").not("#visor").height($("#carcasa").height());
				$('#visor').jScrollPane({
					contentWidth : 0,
					horizontalGutter : -30,
					verticalGutter : -30
				});
				$('#visor').width($('#visor').width()).children().width($('#visor').width());
	} else {

			$('#visor').width($('#content').width());
			$('#visor').jScrollPane({
				contentWidth : 0,
				horizontalGutter : -30,
				verticalGutter : -30
			});

	}
	ims.interfaz.resize();
}


$(document).ready(function() {
	$(".ui-loader,.ui-page").remove();
	document.title = 'Santillana';
	if ($("#url_interfaz").text() != "") {
		url_interfaz = $("#url_interfaz").text();
	};
	$("#url_interfaz").remove();

	config_xml = $.parseXML(config_xml);
	url_files=$(config_xml).find('path').text();
	ims.interfaz.setSound('good', url_interfaz + 'audio/good.mp3');
	ims.interfaz.setSound('rBad', url_interfaz + 'audio/result_bad.mp3');
	ims.interfaz.setSound('rGood', url_interfaz + 'audio/result_good.mp3');
	ims.interfaz.setSound('beep_select', url_interfaz + 'audio/beep_select.mp3');

	ims.interfaz.init();
	inmediastudio.TRAZA.init();

	var overall = "<div id='overall' style='position:absolute;'>" + $("#overall").html() + "</div>";

	$("#overall").remove();
	$("#content").prepend(overall);
	$("#right,#left").css("z-index", "1");
	$("#overall").css("z-index", "0").css("top", 0).css("margin-top", 0).css("position", "absolute");

	if ( typeof (editable) != "undefined") {
		cargar_actividad();
	} else {
		inicializar();
	};
	
});
function inicializar() {
	if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {

		var IntTit = $(config_xml).find("palabras").find("introduccion").text();
		var IntTex = $(config_xml).find("introduccion").find("texto1").text();

		$("#visor").append('<div id="intro_title">' + IntTit + '</div><div id="intro_text">' + IntTex + '</div>');
		ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());
		var comenzar = $(config_xml).find("comenzar").text();

		ims.interfaz.addButton("Siguiente", "right", "siguiente ", comenzar);

		$('#overall').hide();

		ims.interfaz.enable("Siguiente");
		ims.interfaz.bind("Siguiente", 'nextPage()');

		scroll();

	} else {
		cargar_actividad();
	};
};

function crearDesplegable(i) {
	var opciones = $(config_xml).find("combos").find("combo[id=\'" + i + "\']").text().split("#");
	var select = "<select id=\"" + i + "\">";
	select += "<option > </option>";
	for (var i = 0; i < opciones.length; i++) {
		select += "<option value=\"" + opciones[i].replace(/&nbsp;/g, " ") + "\">" + opciones[i].replace("&nbsp;", " ") + "</option>";
	};
	select += "</select>";
	return select;
};
function Remplazo(texto, i) {
	var RegExPattern = /\[(.*?)\]/;
	texto.replace(RegExPattern, function(data) {
		if (data != "") {
			var select = crearDesplegable(i);
			texto = texto.replace(data, select);
			i++;
			texto = Remplazo(texto, i);
		};

	});
	return texto;
};

function cargar_actividad() {

	$(config_xml).find("pregunta").each(function() {
		// Enunciados respuestas y caracteres
		var enunciado = $(this).find("enunciado").text();

		var texto = $(this).find("texto").text();

		//$(config_xml).find("combos").find("combo id='"+i+"'");
		texto = Remplazo(texto.replace(/&nbsp;/g, " "), 0);
		texto = Remplazo(texto.replace(/&quot;/g, '"'), 0);
		$('#pregunta').append(enunciado.replace(/<br>/g, ""));
		//text = texto.find(RegExPattern)
		$("#visor").append('<div id="respuesta">' + texto + '</div>');
		// Imagen de fondo
		if ($(config_xml).find("pregunta").find("foto").length != 0) {
			var foto_object = $(config_xml).find("pregunta").find("foto");
			var foto = foto_object.text();
			var rotation = foto_object.attr("rotation");
			var width = foto_object.attr("width");
			var height = foto_object.attr("height");
			var x = foto_object.attr("x");

			var y = parseInt(foto_object.attr("y"));

			if (foto != '') {

				if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
					var ieversion = new Number(RegExp.$1);

					if (ieversion >= 8) {
						if (url_files != "") {
							foto = url_files + foto;
						} else {
							foto = url_files + foto;
						};
						$("#fondo").append("<div><img style=\"position:absolute;margin-left:" + x + "px;margin-top: " + y + "px;width:" + width + "px; height:" + height + "px; \" src=\"" + foto + "\"/></div>");
						if (x == "" && y == "") {

							height = parseInt($('#fondo div img').height());
							width = parseInt($('#fondo div img').width());

							if (width < $("#fondo").width() || height < $("#fondo").height()) {
								x = $("#fondo").offset().left + $("#fondo").width() - width;
								y = $("#fondo").offset().top + $("#fondo").height() - height;
								$('#fondo div img').css({
									"margin-left" : x + "px ",
									"margin-top" : +y + "px"
								});
							};

						};
					};

				} else {
					if (url_files != "") {
						$('#fondo').css("background-image", "url(" + url_files + foto + ")");
					} else {
						$('#fondo').css("background-image", "url("+url_files + foto + ")");
					};
					$('#fondo').css("background-repeat", "no-repeat");
					if (rotation != '') {
						$('#fondo').css("rotation", rotation);
						if (x != '' || y != '') {
							$('#fondo').css("background-position", x + "px " + y + "px");

							if (width != '' && height != '') {
								$('#fondo').css("background-size", width + "px " + height + "px");
							} else {
								if (height != '') {
									$('#fondo').css("background-size", "auto " + height + "px");
								} else {
									if (width != '') {
										$('#fondo').css("background-size", width + "px auto");
									};
								};
							};

						};
					};
				};

				url = $('#fondo').css('background-image').replace('url(', '').replace(')', '').replace("'", '').replace('"', '');
				bgImg = $('<img />');
				bgImg.hide();

				if (x == "" && y == "") {

					bgImg.bind('load', function() {
						height = parseInt($(this).height());
						width = parseInt($(this).width());

						if (width < $("#fondo").width() || height < $("#fondo").height()) {
							x = $("#fondo").offset().left + $("#fondo").width() - width;
							y = $("#fondo").offset().top + $("#fondo").height() - height;
							$('#fondo').css("background-position", x + "px " + y + "px");
						};

						bgImg.remove();
					});
				};

				$('#fondo').append(bgImg);
				bgImg.attr('src', url);

			};
		};
		// Titulo
		ims.interfaz.setTitle($(config_xml).find("introduccion").find("titulo").text());
		var silenciar = $(config_xml).find("palabras").find("silenciar").text();
		var ayuda = $(config_xml).find("palabras").find("ayuda").text();
		var comprobar = $(config_xml).find("comprobar").text();
		var clave = $(config_xml).find("desarrollo").text();
		var imprimir = $(config_xml).find("imprimir").text();
		var versolucion = $(config_xml).find("versolucion").text();
		var reiniciar = $(config_xml).find("reiniciar").text();

		var volver = $(config_xml).find("volver").text();
		ims.interfaz.addButton("silenciar1", "left", "silenciar", silenciar);

	if ($(config_xml).find("sonido").text() != ''){
		ims.interfaz.addButton( "pausar", "left", "pause", $(config_xml).find("pausa").text());
	  	ims.interfaz.addButton( "player", "left", "play", $(config_xml).find("reproducir").text());
	}
	if (!isMobile && $(config_xml).find("urlimprimir").text().length>0)
		ims.interfaz.addButton("imprimir1", "left", "imprimir", imprimir);
	ims.interfaz.addButton("Anterior", "left", "anterior", volver);
	
	

	ims.interfaz.addButton("ayuda0", "right", "ayuda", ayuda);
	ims.interfaz.addButton("comprobar1", "right", "comprobar", comprobar);
	ims.interfaz.addButton("versolucion2", "right", "versolucion", versolucion);
	ims.interfaz.addButton("clave1", "right", "clave", clave);
	
	ims.interfaz.addButton("reiniciar4","right", "reiniciar", reiniciar);


		if ($(config_xml).find("introduccion").find("texto1").text().length != 0) {
			ims.interfaz.enable("Anterior");
			ims.interfaz.bind("Anterior", 'prevPage()');
		};
			ims.interfaz.enable("silenciar1");

		if (ims.interfaz.sound) {
			ims.interfaz.bind("silenciar1", "mute()");
		} else {
			ims.interfaz.bind("silenciar1", "play()");
		};

		if ($(config_xml).find("ayuda").find("texto1").text().length != 0) {
			ims.interfaz.addPopup("ayuda", "ayuda0");
				var ayudaTit = $(config_xml).find("ayuda").find("titulo").text();
				var ayudaTex = $(config_xml).find("ayuda").find("texto1").text();
				$('#pop_ayuda').prepend("<span class='pop_up_title'>" + ayudaTit + "</span>");
				$('#content_ayuda').append('<div id="contenidoPOP">'+ayudaTex+'</div>');
ims.interfaz.resize();
		};

		ims.interfaz.bind("reiniciar4", 'reload()');
		ims.interfaz.bind("comprobar1", 'comprobar()');
		ims.interfaz.bind("imprimir1", "imprimir()");
		ims.interfaz.enable("reiniciar4");
		ims.interfaz.enable("comprobar1");
		ims.interfaz.enable("imprimir1");

		ims.interfaz.resize();
	});

	if ($.browser.msie && $.browser.version.slice(0, 1) == "8") {
		$("select").css({
			"padding-right" : "0px",
			"padding-left" : "0px"
		});
	};
	var maxWidth = 0;
	// $("select").each(function() {
	// if ($(this).outerWidth() > maxWidth)
	// maxWidth = $(this).outerWidth();
	// });
	// $("select").width(maxWidth);

	var tA = 0;
	$("#ayuda0").click(function() {

		if (tA == 0) {
	$("#content_ayuda").width($("#content_ayuda").width() );

			$('#content_ayuda').jScrollPane({
				showArrows : false,
				hideFocus : true
			});
			tA++;
		}
	});
	scroll();
};

function imprimir() {
	window.open($(config_xml).find("urlimprimir").text(), "Santillana", 'width=800,height=600');
};

function comprobar() {
	if ($("#comprobar1").hasClass("notdisabled")) {

		ims.interfaz.disable("comprobar1");
	$("#comprobar").unbind('click');
	
		if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
		ims.interfaz.bind("versolucion2", 'solucion()');
		$("#versolucion2").addClass("notdisabled");
	}
	else
	{
		$("#reiniciar").unbind('click');
		$("#reiniciar").removeClass("notdisabled");
		$("#Anterior").unbind('click');
		$("#Anterior").removeClass("notdisabled");
	}

		var selects = $("select").length;
		var cor = 0;
		for (var i = 0; i < selects; i++) {
			var iWidth = $("#" + i).outerWidth()+4;
			var iHeight = $("#" + i).outerHeight();


			if ($.browser.msie && $.browser.version.slice(0, 1) == "8") {
				var iWidth = $("#" + i).outerWidth();
			};
			var correctWord = $(config_xml).find("correcta[id=\'" + i + "\']").text().replace("&nbsp;", " "), correctVal = $("#" + i + " option:selected").text();
			
			if ((correctVal == $("<div/>").html(correctWord).text())) {
				cor++;
				if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
				if($("#" + i).val()!=""){
					var value = $("#" + i).val();
				}else{
					var value = "<span style='color:red'>&nbsp;</span>"; 
				}
				var lista = $("<li/>").css({
					"min-width":iWidth,
					height:iHeight,
					"margin-top":"10px",
					"padding":"0px 5px",
					"background":"red",
					"display": "inline-block" 
				}).append(value).addClass("green").attr("id",i);
				$("#" + i).replaceWith(lista);
				ims.interfaz.showStars($("#" + i));
	}
			} else {
				if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
				if($("#" + i).val()!=""){
					var value = $("#" + i).val();
				}else{
					var value = "<span style='color:red'>&nbsp;</span>"; 
				}
				var lista = $("<li/>").css({
					"min-width":iWidth,
					height:iHeight,
					"margin-top":"10px",
					"background":"red",
					"padding":"0px 5px",
					"display": "inline-block" 
				}).append(value).addClass("red").attr("id",i);
				$("#" + i).replaceWith(lista);
	}
			};
		};
		if ($(config_xml).find("ES > solucion").find("texto1").text().length != 0) {
			if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
			ims.interfaz.enable("clave1");
			ims.interfaz.addPopup("solucion", "clave1"); 
	}

			$(config_xml).find("ES > solucion").each(function() {
				var solucionTit = $(this).find("titulo").text();
				var solucionTex = $(this).find("texto1").text();
				$('#pop_solucion').prepend("<span class='pop_up_title'>" + solucionTit + "</span>");
				$('#content_solucion').append('<div id="contenidoPOP">'+solucionTex+'</div>');
			});
			var tS = 0;
			$("#clave1").click(function() {

				if (tS == 0) {
				$("#content_solucion").width($("#content_solucion").width());

					$('#content_solucion').jScrollPane({
						showArrows : false,
						hideFocus : true
					});
					tS++;
				}
				ims.interfaz.resize();
			});

		};

		
		if (cor == parseInt(selects)) {
			if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {

				var ieversion = new Number(RegExp.$1);

				if (ieversion >= 8) {
					if (ims.interfaz.sound == true) {
						if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
						setTimeout(function() {
							$("body").append("<bgsound src=\"audio/good.wav\"  AUTOSTART=\"TRUE\"></bgsound>");
							$("body").append("<bgsound src=\"audio/result.wav\"  AUTOSTART=\"TRUE\"></bgsound>");
						}, 200);
	}
					};
					ims.interfaz.showResults("<p>" + cor + " / " + selects + "</p>", "70");
					if ( inmediastudio.TRAZA.guardarRespuesta ) 
	{ 
		inmediastudio.RESULTADOS.guardarPuntuacion( cor/selects);
	}	

					return false;

				};

			} else {
if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
				ims.interfaz.playSound('rGood');
	}

				ims.interfaz.showResults("<p>" + cor + " / " + selects + "</p>");
				if ( inmediastudio.TRAZA.guardarRespuesta ) 
	{ 
		inmediastudio.RESULTADOS.guardarPuntuacion( cor/selects);
	}	

				return false;

			};

		} else {
			if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {

				var ieversion = new Number(RegExp.$1);

				if (ieversion >= 8) {
					if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
					if (ims.interfaz.sound == true) {
						setTimeout(function() {
							$("body").append("<bgsound src=\"audio/bad.wav\"  AUTOSTART=\"TRUE\"></bgsound>");
							$("body").append("<bgsound src=\"audio/result.wav\"  AUTOSTART=\"TRUE\"></bgsound>");
						}, 200);
					};
							ims.interfaz.showResults("<p>" + cor + " / " + selects + "</p>", "70");
							if ( inmediastudio.TRAZA.guardarRespuesta ) 
	{ 
		inmediastudio.RESULTADOS.guardarPuntuacion( cor/selects);
	}	
	}

				};

			} else {
if ( inmediastudio.TRAZA.mostrarSolucion ) 
	{ 
				ims.interfaz.playSound('rBad');
	}
				ims.interfaz.showResults("<p>" + cor + " / " + selects + "</p>", "70");
				if ( inmediastudio.TRAZA.guardarRespuesta ) 
	{ 
		inmediastudio.RESULTADOS.guardarPuntuacion( cor/selects);
	}	

			};
		};

	};

};

function solucion() {
	if ($("#versolucion2").hasClass("notdisabled")) {
		$("#center").hide();
		$("#center").empty();
		$(".stars").remove();
		ims.interfaz.disable("versolucion2");

		$(config_xml).find("correcta").each(function() {
			var i = $(this).attr("id");
			var lista = $("<li/>").css({
					"min-width":$("#"+i).width(),
					height:$("#"+i).height(),
					"margin-top":"10px",
					"padding":"0px 5px",
					"background":"red",
					"display": "inline-block" 
				}).append($(this).text()).addClass("green").attr("id",i);
				$("#" + i).replaceWith(lista);
			ims.interfaz.showStars($("#" + i));
				$("#" + $(this).attr("id")).height("20");

		});
		if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {

			var ieversion = new Number(RegExp.$1);

			if (ieversion >= 8) {
				if (ims.interfaz.sound == true) {
					setTimeout(function() {
						$("body").append("<bgsound src=\"audio/good.wav\"  AUTOSTART=\"TRUE\"></bgsound>");
					}, 200);
				}
				return false;
			};

		} else {

			ims.interfaz.playSound('good');
			return false;

		};
	};
};

function prevPage() {
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	inicializar();
	retornar();
};

function nextPage() {
	$(".tooltip").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	retornar();
};

function retornar(){
    //Daniel 28/01/2014 d.C
    if (re == 1 && $('#retorno').length == 0){
      // Icono y pasamos parametro a 1
      $('#bottombar').prepend('<div id="retorno"><div id="retornos1" class="button_left sprite background retorno tool notdisabled"></div></div>');
      if (!isMobile){
         $('#left').width($('#left').width()-68);
      }
   }
   $(".retorno").bind(click, function() {
        //Volvemos atrás
        history.back();
    });
}

function reload() {
	$(".tooltip, .stars").remove("");
	$("#limit").remove("");
	ims.interfaz.init();
	var element = $("#visor").jScrollPane().data().jsp;
	element.destroy();
	$("#overall").remove();
	cargar_actividad();
	if (!ims.interfaz.sound) {
		mute();
	};
	retornar();
};

function mute() {
	$('.tooltip').hide();
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar');
	$('#silenciar1').addClass('silenciar_on');
	$('#silenciar1').tooltip();
	ims.interfaz.bind("silenciar1", "play()");
	ims.interfaz.disableSound();
};

function play() {
	$('.tooltip').hide();
	$('#silenciar1').attr('title', $(config_xml).find("silenciar").text());
	$('#silenciar1').removeClass('silenciar_on');
	$('#silenciar1').addClass('silenciar');
	$('#silenciar1').tooltip();
	ims.interfaz.bind("silenciar1", "mute()");
	ims.interfaz.enableSound();
};
